(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
"use strict";

var _SymbolicExecution = _interopRequireDefault(require("./SymbolicExecution"));

var _Config = _interopRequireDefault(require("./Config"));

var _Log = _interopRequireDefault(require("./Utilities/Log"));

var _External = _interopRequireDefault(require("./External"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/* Copyright (c) Royal Holloway, University of London | Contact Blake Loring (blake@parsed.uk), Duncan Mitchell (Duncan.Mitchell.2015@rhul.ac.uk), or Johannes Kinder (johannes.kinder@rhul.ac.uk) for details or support | LICENSE.md for license details */

/*global J$*/
// do not remove the following comment
// JALANGI DO NOT INSTRUMENT
//
// Symbolic execution analyser entry point
var fs = _External["default"].load("fs");

var process = _External["default"].load("process");

var input = process.argv[process.argv.length - 1];

_Log["default"].log("Built with BASE logging enabled");

_Log["default"].log("Intial Input " + input);

process.title = "ExpoSE Play " + input;
process.on("disconnect", function () {
  _Log["default"].log("Premature termination - Parent exit");

  process.exit();
});
J$.analysis = new _SymbolicExecution["default"](J$, JSON.parse(input), function (state, coverage) {
  _Log["default"].log("Finished play with PC " + state.pathCondition.map(function (x) {
    return x.ast;
  }));

  if (_Config["default"].outCoveragePath) {
    fs.writeFileSync(_Config["default"].outCoveragePath, JSON.stringify(coverage.end()));

    _Log["default"].log("Wrote final coverage to " + _Config["default"].outCoveragePath);
  } else {
    _Log["default"].log("No final coverage path supplied");
  } //We record the alternatives list as the results develop to make the output tool more resilient to SMT crashes


  state.alternatives(function (current) {
    var finalOut = {
      pc: state.finalPC(),
      input: state.input,
      errors: state.errors,
      alternatives: current,
      stats: state.stats["export"]()
    };

    if (_Config["default"].outFilePath) {
      fs.writeFileSync(_Config["default"].outFilePath, JSON.stringify(finalOut));

      _Log["default"].log("Wrote final output to " + _Config["default"].outFilePath);
    } else {
      _Log["default"].log("No final output path supplied");
    }
  });
});
},{"./Config":2,"./External":4,"./SymbolicExecution":15,"./Utilities/Log":19}],2:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _External = _interopRequireDefault(require("./External"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/* Copyright (c) Royal Holloway, University of London | Contact Blake Loring (blake@parsed.uk), Duncan Mitchell (Duncan.Mitchell.2015@rhul.ac.uk), or Johannes Kinder (johannes.kinder@rhul.ac.uk) for details or support | LICENSE.md for license details */
var process = _External["default"].load("process");

function Default(i, d) {
  var envvar = process.env["EXPOSE_".concat(i)];
  return envvar || d;
}

var _default = {
  incrementalSolverEnabled: !!Default("USE_INCREMENTAL_SOLVER", true),
  maxRefinements: Number.parseInt(Default("MAX_REFINEMENTS", "40")),
  maxSolverTime: Number.parseInt(Default("MAX_SOLVER_TIME", 1800000)),
  regexEnabled: !Default("DISABLE_REGULAR_EXPRESSIONS", false),
  capturesEnabled: !Default("DISABLE_CAPTURE_GROUPS", false),
  refinementsEnabled: !Default("DISABLE_REFINEMENTS", false),
  outFilePath: Default("OUT_PATH", undefined),
  outCoveragePath: Default("COVERAGE_PATH", undefined),
  outQueriesDir: Default("QUERY_DUMP", undefined),
  stringSolver: Default("STRING_SOLVER", "seq")
};
exports["default"] = _default;
},{"./External":4}],3:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _iidToLocation = _interopRequireDefault(require("./Utilities/iidToLocation"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var LAST_IID = "LAST_IID";
/**
 * Bits for coverage info propagation
 */

var IS_TOUCHED = 0x1;
var CONDITIONAL_TRUE = 0x2;
var CONDITIONAL_FALSE = 0x4;

var Coverage = /*#__PURE__*/function () {
  /**
      * Creates an instance of Coverage.
      * @param {any} sandbox The Jalangi sandbox
      * _branches is an array of coverages for a given sid where the sid is branches[sid+1]
      * @memberOf Coverage
      */
  function Coverage(sandbox) {
    _classCallCheck(this, Coverage);

    this._sandbox = sandbox;
    this._branches = [];
    this._branchFilenameMap = [];
    this._lastIid = 0; //Store the last IID touched for search strategizer
  }

  _createClass(Coverage, [{
    key: "end",
    value: function end() {
      var payload = {};

      for (var i = 0; i < this._branches.length; i++) {
        //SID are indexed from 1 not 0
        var localSid = i + 1;

        if (this._branches[i] !== undefined) {
          //Deep copy the smap
          var map = JSON.parse(JSON.stringify(this._sandbox.smap[localSid])); //Strip away any non SID related entities

          for (var localIid in map) {
            if (isNaN(parseInt(localIid))) {
              delete map[localIid];
            } else {
              map[localIid] = (0, _iidToLocation["default"])(this._sandbox, localSid, localIid);
            }
          }

          payload[this._branchFilenameMap[i]] = {
            smap: map,
            branches: this._branches[i]
          };
        }
      }

      payload[LAST_IID] = this._lastIid;
      return payload;
    }
  }, {
    key: "getBranchInfo",
    value: function getBranchInfo() {
      //-1 from 1-indexed sid to start from 0
      var localIndex = this._sandbox.sid - 1;
      var branchInfo = this._branches[localIndex];

      if (!branchInfo) {
        branchInfo = {};
        this._branches[localIndex] = branchInfo;
        var map = this._sandbox.smap[this._sandbox.sid];
        this._branchFilenameMap[localIndex] = map ? map.originalCodeFileName : "Broken Filename";
      }

      return branchInfo;
    }
  }, {
    key: "touch",
    value: function touch(iid) {
      this.getBranchInfo()[iid] |= IS_TOUCHED;
      this._lastIid = iid;
    }
  }, {
    key: "touch_cnd",
    value: function touch_cnd(iid, result) {
      this.touch(iid);
      this.getBranchInfo()[iid] |= result ? CONDITIONAL_TRUE : CONDITIONAL_FALSE;
    }
  }, {
    key: "last",
    value: function last() {
      return this._lastIid || 0;
    }
  }]);

  return Coverage;
}();

var _default = Coverage;
exports["default"] = _default;
},{"./Utilities/iidToLocation":21}],4:[function(require,module,exports){
(function (process){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

/* Copyright (c) Royal Holloway, University of London | Contact Blake Loring (blake@parsed.uk), Duncan Mitchell (Duncan.Mitchell.2015@rhul.ac.uk), or Johannes Kinder (johannes.kinder@rhul.ac.uk) for details or support | LICENSE.md for license details */

/* global window */
function is_external() {
  return typeof window !== "undefined";
}

function calectron() {
  if (!window._ELC) {
    window._ELC = require("electron");
  }

  return window._ELC;
} //Cache electron so require doesn't get rewritten


var ld = is_external() ? calectron().remote.require : require;
var electronWindow = is_external() ? calectron().remote.getCurrentWindow() : null;
var _default = {
  load: function load(library) {
    return ld(library);
  },
  close: function close() {
    if (electronWindow) {
      electronWindow.close();
    } else {
      process.exit(0);
    }
  },
  is_external: is_external
};
exports["default"] = _default;
}).call(this,require('_process'))
},{"_process":25,"electron":undefined}],5:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _WrappedValue = require("../Values/WrappedValue");

var _Log = _interopRequireDefault(require("../Utilities/Log"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _default(state, ctx, model, helper) {
  var symbolicHook = helper.symbolicHook;
  var mkFunctionName = helper.mkFunctionName;
  var mkIndexSymbol = helper.mkIndexSymbol;
  var NoOp = helper.NoOp;
  model.add(Array.prototype.push, function (base, args) {
    var is_symbolic = state.isSymbolic(base);

    var args_well_formed = state.getConcrete(base) instanceof Array && state.arrayType(base) == _typeof(state.getConcrete(args[0]));

    if (is_symbolic && args_well_formed) {
      _Log["default"].log("Push symbolic prototype");

      var array = state.asSymbolic(base);
      var value = state.asSymbolic(args[0]);
      var oldLength = array.getLength();
      var newLength = ctx.mkAdd(oldLength, ctx.mkIntVal(1));
      state.getConcrete(base).push(state.getConcrete(args[0]));
      state.updateSymbolic(base, array.setField(oldLength, value).setLength(newLength));
      return args[0];
    } else {
      //TODO: Check that this mechanism for removing-symbolicness actually works
      //TODO: The goal here is to concretize this result from here-on in as the concrete model might be non-homogonous
      if (state.isSymbolic(base)) {
        state.updateSymbolic(base, null);
      }

      return state.getConcrete(base).push(args[0]);
    }
  });
  model.add(Array.prototype.pop, function (base, args) {
    var is_symbolic = state.isSymbolic(base);

    var args_well_formed = state.getConcrete(base) instanceof Array && state.arrayType(base) == _typeof(state.getConcrete(args[0]));

    _Log["default"].log("TODO: Push prototype is not smart enough to decide array type");

    if (is_symbolic && args_well_formed) {
      _Log["default"].log("Push symbolic prototype");

      var array = state.asSymbolic(base);
      var oldLength = array.getLength();
      var newLength = ctx.mkAdd(oldLength, ctx.mkIntVal(-1));
      var result = new _WrappedValue.ConcolicValue(state.getConcrete(base).pop(), state.getField(oldLength));
      state.updateSymbolic(base, array.setLength(newLength));
      return result;
    } else {
      //TODO: Check this works (See push)
      if (state.isSymbolic(base)) {
        state.updateSymbolic(base, null);
      }

      return state.getConcrete(base).pop();
    }
  });
  model.add(Array.prototype.indexOf, symbolicHook(Array.prototype.indexOf, function (base, _args) {
    var is_symbolic = state.isSymbolic(base) && state.getConcrete(base) instanceof Array;
    return is_symbolic;
  }, function (base, args, result) {
    var searchTarget = state.asSymbolic(args[0]);
    var result_s = mkIndexSymbol("IndexOf"); //The result is an integer -1 <= result_s < base.length

    state.pushCondition(ctx.mkGe(result_s, ctx.mkIntVal(-1)), true);
    state.pushCondition(ctx.mkGt(state.asSymbolic(base).getLength(), result_s), true); // either result_s is a valid index for the searchtarget or -1

    state.pushCondition(ctx.mkOr(ctx.mkEq(ctx.mkSelect(state.asSymbolic(base), result_s), searchTarget), ctx.mkEq(result_s, ctx.mkIntVal(-1))), true
    /* Binder */
    ); // If result != -1 then forall 0 < i < result select base i != target

    var intSort = ctx.mkIntSort();
    var i = ctx.mkBound(0, intSort);
    var match_func_decl_name = mkFunctionName("IndexOf");
    var iLessThanResult = ctx.mkPattern([ctx.mkLt(i, result_s), ctx.mkGe(i, ctx.mkIntVal(0))]);
    var matchInArrayBody = ctx.mkImplies(ctx.mkAnd(ctx.mkGe(i, ctx.mkIntVal(0)), ctx.mkLt(i, result_s)), ctx.mkNot(ctx.mkEq(ctx.mkSelect(state.asSymbolic(base), i), searchTarget)));
    var noPriorUse = ctx.mkForAll([match_func_decl_name], intSort, matchInArrayBody, [iLessThanResult]);
    state.pushCondition(ctx.mkImplies(ctx.mkGt(result_s, ctx.mkIntVal(-1)), noPriorUse), true);
    return new _WrappedValue.ConcolicValue(result, result_s);
  }));
  model.add(Array.prototype.includes, symbolicHook(Array.prototype.includes, function (base, args) {
    var is_symbolic = state.isSymbolic(base);

    var args_well_formed = state.getConcrete(base) instanceof Array && state.arrayType(base) == _typeof(state.getConcrete(args[0]));

    return is_symbolic && args_well_formed;
  }, function (base, args, result) {
    var searchTarget = state.asSymbolic(args[0]);
    var intSort = ctx.mkIntSort();
    var i = ctx.mkBound(0, intSort);
    var lengthBounds = ctx.mkAnd(ctx.mkGe(i, ctx.mkIntVal(0)), ctx.mkLt(i, state.asSymbolic(base).getLength()));
    var body = ctx.mkAnd(lengthBounds, ctx.mkEq(ctx.mkSelect(state.asSymbolic(base), i), searchTarget));
    var iPattern = ctx.mkPattern([ctx.mkLt(i, state.asSymbolic(base).getLength()), ctx.mkGe(i, ctx.mkIntVal(0))]);
    var func_decl_name = mkFunctionName("Includes");
    var result_s = ctx.mkExists([func_decl_name], intSort, body, [iPattern]);
    return new _WrappedValue.ConcolicValue(result, result_s);
  }));
  model.add(Array.prototype.join, function (base, args) {
    var isSymbolicVal = Array.prototype.find.call(base, function (x) {
      return state.isSymbolic(x);
    });

    if (!isSymbolicVal) {
      return Array.prototype.join.apply(base, args);
    }

    var sep = args[0] ? helper.coerceToString(args[0]) : ',';
    var finalString = '';

    for (var i = 0; i < base.length; i++) {
      if (i > 0) {
        finalString = state.binary('+', finalString, sep);
      }

      finalString = state.binary('+', finalString, helper.coerceToString(base[i]));
    }

    return finalString;
  });
  model.add(Array.prototype.keys, NoOp(Array.prototype.keys));
  model.add(Array.prototype.concat, NoOp(Array.prototype.concat));
  model.add(Array.prototype.forEach, NoOp(Array.prototype.forEach)); //TODO: This should only be a no op if the function given as a forEach is not native

  model.add(Array.prototype.filter, NoOp(Array.prototype.filter)); //TODO: This should only be a no op if the function given as a filter  is not native

  model.add(Array.prototype.map, NoOp(Array.prototype.map)); // ^^

  model.add(Array.prototype.shift, NoOp(Array.prototype.shift));
  model.add(Array.prototype.unshift, NoOp(Array.prototype.unshift));
  model.add(Array.prototype.fill, NoOp(Array.prototype.fill));
  model.add(Array.prototype.reduce, NoOp(Array.prototype.reduce)); //TODO: This should only be a no-op if the function given as a reducer is not native 
}
},{"../Utilities/Log":19,"../Values/WrappedValue":23}],6:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _WrappedValue = require("../Values/WrappedValue");

var _Log = _interopRequireDefault(require("../Utilities/Log"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _default(state, ctx, models, helper) {
  if (typeof window !== "undefined") {
    models.add(Element.prototype.getAttribute, helper.NoOp(Element.prototype.getAttribute));
    models.add(Element.prototype.setAttribute, helper.NoOp(Element.prototype.setAttribute));
  }

  models.add(encodeURI, function (base, args) {
    var result = new _WrappedValue.ConcolicValue(encodeURI.call(base, state.getConcrete(args[0])), state.asSymbolic(args[0]));
    return result;
  });
  models.add(encodeURIComponent, function (base, args) {
    if (state.isSymbolic(args[0])) {
      args[0] = helper.coerceToString(args[0]);
      var result = new _WrappedValue.ConcolicValue(encodeURIComponent.call(base, state.getConcrete(args[0])), state.asSymbolic(args[0]));
      return result;
    }
  });
}
},{"../Utilities/Log":19,"../Values/WrappedValue":23}],7:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

function _default(state, ctx, model, helpers) {
  var ConcretizeIfNative = helpers.ConcretizeIfNative; //TODO: Test IsNative for apply, bind & call

  model.add(Function.prototype.apply, ConcretizeIfNative(Function.prototype.apply));
  model.add(Function.prototype.call, ConcretizeIfNative(Function.prototype.call));
  model.add(Function.prototype.bind, ConcretizeIfNative(Function.prototype.bind));
  model.add(Object.prototype.hasOwnProperty, function (base, args) {
    for (var i = 0; i < args.length; i++) {
      args[i] = state.getConcrete(args[i]);
    }

    return Object.prototype.hasOwnProperty.apply(state.getConcrete(base), args);
  });
  model.add(Object.prototype.keys, function (base, args) {
    for (var i = 0; i < args.length; i++) {
      args[i] = state.getConcrete(args[i]);
    }

    return Object.prototype.keys.apply(state.getConcrete(base), args);
  });
  model.add(Object.assign, function (base, args) {
    return Object.assign.call(base, state.getConcrete(args[0]), state.getConcrete(args[1]));
  });
  model.add(Array.isArray, function (base, args) {
    return Array.isArray.call(base, state.getConcrete(args[0]));
  });
  model.add(console.log, function (base, args) {
    for (var i = 0; i < args.length; i++) {
      args[i] = state.getConcrete(args[i]);
    }

    console.log.apply(base, args);
  });
}
},{}],8:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _Config = _interopRequireDefault(require("../Config"));

var _WrappedValue = require("../Values/WrappedValue");

var _Log = _interopRequireDefault(require("../Utilities/Log"));

var _ObjectHelper = _interopRequireDefault(require("../Utilities/ObjectHelper"));

var _IsNative = require("../Utilities/IsNative");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var map = Array.prototype.map;

function _default(state, ctx, model) {
  function runMethod(f, base, args) {
    var concretize = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
    var result, thrown; //Defer throw until after hook has run

    try {
      var c_base = concretize ? state.getConcrete(base) : base;
      var c_args = concretize ? map.call(args, function (arg) {
        return state.getConcrete(arg);
      }) : args;
      result = f.apply(c_base, c_args);
    } catch (e) {
      thrown = e;
    }

    return [result, thrown];
  }
  /**
   * Symbolic hook is a helper function which builds concrete results and then,
   * if condition() -> true executes a symbolic helper specified by hook
   * Both hook and condition are called with (context (SymbolicExecutor), f, base, args, result)
   *
   * A function which makes up the new function model is returned
   */


  function symbolicHook(f, condition, hook) {
    var concretize = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
    var featureDisabled = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
    return function (base, args) {
      var _runMethod = runMethod(f, base, args, concretize),
          _runMethod2 = _slicedToArray(_runMethod, 2),
          result = _runMethod2[0],
          thrown = _runMethod2[1];

      if (!featureDisabled && condition(base, args)) {
        result = hook(base, args, result);
      }

      if (thrown) {
        throw thrown;
      }

      return result;
    };
  }

  function ConcretizeIfNative(f) {
    return function (base, args) {
      base = state.getConcrete(base);

      if ((0, _IsNative.isNative)(base)) {
        var concretized = state.concretizeCall(f, base, args, false);
        base = concretized.base;
        args = concretized.args;
      }

      return f.apply(base, args);
    };
  }

  function coerceToString(symbol) {
    return state.ToString(symbol);
  }

  function NoOp(f) {
    return function (base, args) {
      return f.apply(base, args);
    };
  }
  /**
   * In JavaScript slice and substr can be given a negative index to indicate addressing from the end of the array
   * We need to rewrite the SMT to handle these cases
   */


  function substringHandleNegativeLengths(base_s, index_s) {
    //Index s is negative to adding will get us to the right start
    var newIndex = ctx.mkAdd(base_s.getLength(), index_s); //Bound the minimum index by 0

    var aboveMin = ctx.mkGe(newIndex, ctx.mkIntVal(0));
    var indexOrZero = ctx.mkIte(aboveMin, newIndex, ctx.mkIntVal(0));
    return ctx.mkIte(ctx.mkGe(index_s, ctx.mkIntVal(0)), index_s, indexOrZero);
  }

  function substringHelper(base, args, result) {
    state.stats.seen("Symbolic Substrings");
    var target = state.asSymbolic(base); //The start offset is either the argument of str.len - the arguments

    var start_off = ctx.mkRealToInt(state.asSymbolic(args[0]));
    start_off = substringHandleNegativeLengths(target, start_off); //Length defaults to the entire string if not specified

    var len;
    var maxLength = ctx.mkSub(target.getLength(), start_off);

    if (args[1]) {
      len = state.asSymbolic(args[1]);
      len = ctx.mkRealToInt(len); //If the length is user-specified bound the length of the substring by the maximum size of the string ("123".slice(0, 8) === "123")

      var exceedMax = ctx.mkGe(ctx.mkAdd(start_off, len), target.getLength());
      len = ctx.mkIte(exceedMax, maxLength, len);
    } else {
      len = maxLength;
    } //If the start index is greater than or equal to the length of the string the empty string is returned


    var substr_s = ctx.mkSeqSubstr(target, start_off, len);
    var empty_s = ctx.mkString("");
    var result_s = ctx.mkIte(ctx.mkGe(start_off, target.getLength()), empty_s, substr_s);
    return new _WrappedValue.ConcolicValue(result, result_s);
  }

  var indexOfCounter = 0;

  function mkIndexSymbol(op) {
    return ctx.mkIntVar("_".concat(op, "_").concat(indexOfCounter++, ")"));
  }

  var funcCounter = 0;

  function mkFunctionName(fn) {
    return ctx.mkStringSymbol("_fn_".concat(fn, "_").concat(funcCounter++, "_"));
  }

  return {
    mkFunctionName: mkFunctionName,
    mkIndexSymbol: mkIndexSymbol,
    runMethod: runMethod,
    symbolicHook: symbolicHook,
    ConcretizeIfNative: ConcretizeIfNative,
    coerceToString: coerceToString,
    NoOp: NoOp,
    substring: substringHelper
  };
}
},{"../Config":2,"../Utilities/IsNative":18,"../Utilities/Log":19,"../Utilities/ObjectHelper":20,"../Values/WrappedValue":23}],9:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _WrappedValue = require("../Values/WrappedValue");

var _Log = _interopRequireDefault(require("../Utilities/Log"));

var _External = _interopRequireDefault(require("../External"));

var _z3javascript = _interopRequireDefault(require("z3javascript"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _createForOfIteratorHelper(o) { if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (o = _unsupportedIterableToArray(o))) { var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var it, normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var find = Array.prototype.find;

function _default(state, ctx, model, helpers) {
  function symbolicStringify(field) {
    if (field === undefined) {
      return undefined;
    } else if (field === null) {
      return "null";
    } else if (state.getConcrete(field) instanceof Array) {
      var rstr = '[';
      field = state.getConcrete(field);

      for (var i = 0; i < field.length; i++) {
        if (i > 0) {
          rstr = state.binary('+', rstr, ', ');
        }

        rstr = state.binary('+', rstr, symbolicStringify(field[i]));
      }

      rstr = state.binary('+', rstr, ']');
      return rstr;
    } else if (state.getConcrete(field) instanceof Object) {
      var _rstr = '{';
      var first = true;

      var _iterator = _createForOfIteratorHelper(Object.getOwnPropertyNames(field)),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var key = _step.value;
          var name = state.binary('+', '"', state.binary('+', key, '"'));
          var encodedField = symbolicStringify(field[key]);
          var merged = state.binary('+', name, state.binary('+', ':', encodedField));

          if (!first) {
            _rstr = state.binary('+', _rstr, ',');
          }

          _rstr = state.binary('+', _rstr, merged);
          first = false;
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      _rstr = state.binary('+', _rstr, '}');
      return _rstr;
    } else if (typeof state.getConcrete(field) === "string") {
      return state.binary('+', '"', state.binary('+', field, '"'));
    } else {
      return helpers.coerceToString(field);
    }
  }

  model.add(JSON.stringify, function (base, args) {
    var result = symbolicStringify(args[0]);
    return result;
  });
}
},{"../External":4,"../Utilities/Log":19,"../Values/WrappedValue":23,"z3javascript":undefined}],10:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _WrappedValue = require("../Values/WrappedValue");

function _default(state, ctx, model, helper) {
  var symbolicHook = helper.symbolicHook;
  /**
   * TODO: Floor and Ceil should -1 or +1 if args[0] > or < the result
   */

  model.add(Math.floor, symbolicHook(Math.floor, function (base, args) {
    return state.isSymbolic(args[0]);
  }, function (base, args, r) {
    var intArg = ctx.mkRealToInt(state.asSymbolic(args[0]));
    var floored = ctx.mkIntToReal(intArg);
    return new _WrappedValue.ConcolicValue(r, floored);
  }));
  model.add(Math.ceil, symbolicHook(Math.ceil, function (base, args) {
    return state.isSymbolic(args[0]);
  }, function (base, args, r) {
    var origin = state.asSymbolic(args[0]);
    var intArg = ctx.mkRealToInt(origin);
    var floored = ctx.mkIntToReal(intArg);
    return new _WrappedValue.ConcolicValue(r, ctx.mkIte(ctx.mkEq(floored, origin), floored, ctx.mkAdd(floored, state.asSymbolic(1))));
  }));
  model.add(Math.round, symbolicHook(Math.round, function (base, args) {
    return state.isSymbolic(args[0]);
  }, function (base, args, r) {
    var originArg = state.asSymbolic(args[0]);
    var intArg = ctx.mkRealToInt(originArg);
    var floored = ctx.mkIntToReal(intArg);
    var half = state.constantSymbol(0.5);
    var whole = state.constantSymbol(1);
    return new _WrappedValue.ConcolicValue(r, ctx.mkIte(ctx.mkLt(ctx.mkAdd(floored, half), originArg), ctx.mkAdd(floored, whole), floored));
  }));
  model.add(Math.abs, symbolicHook(Math.abs, function (base, args) {
    return state.isSymbolic(args[0]);
  }, function (base, args, r) {
    var arg_s = state.asSymbolic(args[0]);
    return new _WrappedValue.ConcolicValue(r, ctx.mkIte(ctx.mkLt(arg_s, state.asSymbolic(0)), ctx.mkUnaryMinus(arg_s), arg_s));
  }));
}

;
},{"../Values/WrappedValue":23}],11:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _NotAnErrorException = _interopRequireDefault(require("../NotAnErrorException"));

var _IsNative = require("../Utilities/IsNative");

var _WrappedValue = require("../Values/WrappedValue");

var _Helpers = _interopRequireDefault(require("./Helpers"));

var _MathModels = _interopRequireDefault(require("./MathModels"));

var _ArrayModels = _interopRequireDefault(require("./ArrayModels"));

var _StringModels = _interopRequireDefault(require("./StringModels"));

var _FnModels = _interopRequireDefault(require("./FnModels"));

var _RegexModels = _interopRequireDefault(require("./RegexModels"));

var _DOMModels = _interopRequireDefault(require("./DOMModels"));

var _JSONModels = _interopRequireDefault(require("./JSONModels"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/* Copyright (c) Royal Holloway, University of London | Contact Blake Loring (blake@parsed.uk), Duncan Mitchell (Duncan.Mitchell.2015@rhul.ac.uk), or Johannes Kinder (johannes.kinder@rhul.ac.uk) for details or support | LICENSE.md for license details */
function Model() {
  this._models = [];

  this.add = function (fn, _mdl) {
    this._models.push({
      fn: fn,
      mdl: function mdl() {
        return _mdl.call(null, this, arguments);
      }
    });
  };

  this.get = function (fn) {
    var found = this._models.find(function (x) {
      return x.fn == fn;
    });

    return found ? found.mdl : null;
  };
}
/**
 * Builds a set of function models bound to a given SymbolicState
 */


function BuildModels(state) {
  var ctx = state.ctx;
  var model = new Model();
  var helpers = (0, _Helpers["default"])(state, ctx, model);
  (0, _MathModels["default"])(state, ctx, model, helpers);
  (0, _StringModels["default"])(state, ctx, model, helpers);
  (0, _RegexModels["default"])(state, ctx, model, helpers);
  (0, _ArrayModels["default"])(state, ctx, model, helpers);
  (0, _FnModels["default"])(state, ctx, model, helpers);
  (0, _DOMModels["default"])(state, ctx, model, helpers);
  (0, _JSONModels["default"])(state, ctx, model, helpers);
  /**
   * Models for methods on Object
   */

  model.add(Object, function (base, args) {
    var concrete = state.concretizeCall(Object, base, args, false);
    var result = Object.apply(concrete.base, concrete.args);

    if (!(concrete.args[0] instanceof Object) && state.isSymbolic(args[0])) {
      result = new _WrappedValue.ConcolicValue(result, state.asSymbolic(args[0]));
    }

    return result;
  });
  /**
   * Secret _expose hooks for symbols.js
   */

  Object._expose = {};

  Object._expose.makeSymbolic = function (name, initial) {
    return state.createSymbolicValue(name, initial);
  };

  Object._expose.notAnError = function () {
    return _NotAnErrorException["default"];
  };

  Object._expose.pureSymbol = function (name) {
    return state.createPureSymbol(name);
  };

  return model;
}

var _default = BuildModels;
exports["default"] = _default;
},{"../NotAnErrorException":14,"../Utilities/IsNative":18,"../Values/WrappedValue":23,"./ArrayModels":5,"./DOMModels":6,"./FnModels":7,"./Helpers":8,"./JSONModels":9,"./MathModels":10,"./RegexModels":12,"./StringModels":13}],12:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _WrappedValue = require("../Values/WrappedValue");

var _Config = _interopRequireDefault(require("../Config"));

var _Log = _interopRequireDefault(require("../Utilities/Log"));

var _External = _interopRequireDefault(require("../External"));

var _z3javascript = _interopRequireDefault(require("z3javascript"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var isMatchCount = 0;

function _default(state, ctx, model, helpers) {
  var coerceToString = helpers.coerceToString; //Hook for regex methods, will only hook if regex is enabled

  function symbolicHookRe(f, condition, hook) {
    var runMethod = helpers.runMethod;
    return function (base, args) {
      if (_Config["default"].regexEnabled && condition(base, args)) {
        return hook(base, args);
      } else {
        var _runMethod = runMethod(f, base, args),
            _runMethod2 = _slicedToArray(_runMethod, 2),
            result = _runMethod2[0],
            thrown = _runMethod2[1];

        if (thrown) {
          throw thrown;
        }

        return result;
      }
    };
  }

  function DoesntMatch(l, r) {
    if (l == undefined) {
      var is_match = r == "" || r == undefined;
      return !is_match;
    } else {
      return l !== r;
    }
  }

  function Exists(array1, array2, pred) {
    for (var i = 0; i < array1.length; i++) {
      if (pred(array1[i], array2[i])) {
        return true;
      }
    }

    return false;
  }

  function EnableCaptures(regex, real, string_s) {
    if (!_Config["default"].capturesEnabled) {
      _Log["default"].log("Captures disabled - potential loss of precision");
    }

    var implies = ctx.mkImplies(ctx.mkSeqInRe(string_s, regex.ast), ctx.mkEq(string_s, regex.implier)); //Mock the symbolic conditional if (regex.test(/.../) then regex.match => true)

    regex.assertions.forEach(function (binder) {
      return state.pushCondition(binder, true);
    });
    state.pushCondition(implies, true);
  }

  function BuildRefinements(regex, real, string_s, is_match_s) {
    //The refinements operate on the remainder of the string so we no longer care about the sticky / global rules
    real = new RegExp(real.source, real.flags.replace(/y|g/g, ""));

    if (!(_Config["default"].capturesEnabled && _Config["default"].refinementsEnabled)) {
      _Log["default"].log("Refinements disabled - potential accuracy loss");

      return [];
    }

    _Log["default"].log("Refinements Enabled - Adding checks");

    state.stats.seen("Regex Which May Need Checks"); //TODO: This is a workaround as calling asConstant on is_match_s doesn't work
    //Remove when we get a reply from the Z3 guys

    var isMatch = ctx.mkBoolVar('IsMatch_' + real + '_' + isMatchCount++);
    state.pushCondition(ctx.mkEq(is_match_s, isMatch), true);

    function CheckCorrect(model) {
      if (model.eval(isMatch).asConstant(model)) {
        //Only apply this check if str.in.re .... was meant to be true
        state.stats.seen("Regex Checks");
        var real_match = real.exec(model.eval(string_s).asConstant(model));
        var sym_match = regex.captures.map(function (cap) {
          return model.eval(cap).asConstant(model);
        });
        var is_correct = real_match && !Exists(real_match, sym_match, DoesntMatch);

        if (!is_correct) {
          state.stats.seen("Failed Regex Checks");
        }

        return is_correct;
      } else {
        return true;
      }
    }

    function CheckFailed(model) {
      if (!model.eval(isMatch).asConstant(model)) {
        state.stats.seen("Regex Checks");
        var is_failed = !real.test(model.eval(string_s).asConstant(model));

        if (!is_failed) {
          state.stats.seen("Failed Regex Checks");
        }

        return is_failed;
      } else {
        return true;
      }
    }

    var NotMatch = _z3javascript["default"].Check(CheckCorrect, function (query, model) {
      var not = ctx.mkNot(ctx.mkEq(string_s, ctx.mkString(model.eval(string_s).asConstant(model))));
      return [new _z3javascript["default"].Query(query.exprs.slice(0).concat([not]), [CheckFixed, NotMatch])];
    });
    /**
     * Generate a fixed string refinement (c_0, c_n, ...) == (e_0, e_n, ...)
     */


    var CheckFixed = _z3javascript["default"].Check(CheckCorrect, function (query, model) {
      var real_match = real.exec(model.eval(string_s).asConstant(model));

      if (!real_match) {
        _Log["default"].log("WARN: Broken regex detected ".concat(regex.ast.toString(), " vs ").concat(real, " in ").concat(model.eval(string_s).asConstant(model)));

        return [];
      }

      real_match = real_match.map(function (match) {
        return match || "";
      });
      var query_list = regex.captures.map(function (cap, idx) {
        return ctx.mkEq(ctx.mkString(real_match[idx]), cap);
      });
      return [new _z3javascript["default"].Query(query.exprs.slice(0).concat(query_list), [])];
    });

    var CheckNotIn = _z3javascript["default"].Check(CheckFailed, function (query, model) {
      var not = ctx.mkNot(ctx.mkEq(string_s, ctx.mkString(model.eval(string_s).asConstant(model))));
      return [new _z3javascript["default"].Query(query.exprs.slice(0).concat([not]), [CheckNotIn])];
    });

    return [CheckFixed, NotMatch, CheckNotIn];
  }
  /** As an optimization we implement test differently, this allows us to not generated extra paths when not needed on usage **/


  function RegexpBuiltinTest(regex, string) {
    var currentLastIndex = regex.lastIndex;
    regex.lastIndex = state.getConcrete(regex.lastIndex);
    var is_match_c = regex.test(state.getConcrete(string));

    if (regex.sticky || regex.global) {
      //Cut at regex.lastIndex
      state.stats.seen('Sticky (RegexBuiltinExec)');
      string = model.get(String.prototype.substring).call(string, currentLastIndex);

      if (!regex.source[0] != '^') {
        _Log["default"].log("In Sticky Mode We Insert ^");

        regex = new RegExp('^' + regex.source, regex.flags);
      }
    }

    state.stats.seen('Regex Encoded');

    var regexEncoded = _z3javascript["default"].Regex(ctx, regex);

    var is_match_s = ctx.mkSeqInRe(state.asSymbolic(string), regexEncoded.ast);
    console.log("|REGEX ENCODING| ".concat(regex, ".exec(").concat(state.asSymbolic(string).toString(), ") -> (").concat(regexEncoded.anchoredStart ? regexEncoded.anchoredStart.toString() : '', ", ").concat(regexEncoded.anchoredEnd ? regexEncoded.anchoredEnd.toString() : '', ") (").concat(regexEncoded.captures.reduce(function (last, capture, idx) {
      return last + (idx > 0 ? ',' : '') + capture.toString();
    }, ''), ")"));
    EnableCaptures(regexEncoded, regex, state.asSymbolic(string));
    is_match_s.checks = BuildRefinements(regexEncoded, regex, state.asSymbolic(string), is_match_s);

    if (_Config["default"].capturesEnabled && (regex.sticky || regex.global)) {
      _Log["default"].log('Captures enabled - symbolic lastIndex enabled');

      regexEncoded.startIndex = ctx.mkAdd(state.asSymbolic(currentLastIndex), regexEncoded.startIndex);
      regex.lastIndex = new _WrappedValue.ConcolicValue(regex.lastIndex, ctx.mkIte(is_match_s, ctx.mkAdd(state.asSymbolic(currentLastIndex), regexEncoded.captures[0].getLength()), ctx.mkIntVal(0)));
    }

    return {
      result: new _WrappedValue.ConcolicValue(is_match_c, is_match_s),
      encodedRegex: regexEncoded
    };
  }

  function RegexpBuiltinExec(regex, string) {
    //Preserve the lastIndex property
    var lastIndex = regex.lastIndex;
    var test = RegexpBuiltinTest(regex, string);
    regex.lastIndex = lastIndex;
    state.conditional(test.result); //Fork on the str.in.re operation

    var result_c = regex.exec(state.getConcrete(string));

    if (_Config["default"].capturesEnabled && result_c) {
      //If str.in.re is success & captures are enabled then rewrite the capture results
      var nr = [];

      for (var i = 0; i < result_c.length; i++) {
        //TODO: Alias type symbolically for strings String = Undefined | String THIS IS BAD
        nr.push(new _WrappedValue.ConcolicValue(result_c[i] === undefined ? "" : result_c[i], test.encodedRegex.captures[i]));
      } //Start Index can only be computed when we have captures enabled


      nr.index = new _WrappedValue.ConcolicValue(result_c.index, test.encodedRegex.startIndex);
      nr.input = string;
      result_c = nr;
    }

    return {
      result: result_c,
      encodedRegex: test.encodedRegex
    };
  }

  function RegexpBuiltinMatch(regex, string) {
    if (regex.global) {
      //Remove g and y from regex
      var rewrittenRe = new RegExp(regex.source, regex.flags.replace(/g|y/g, "") + "y");
      var results = [];

      while (true) {
        var next = RegexpBuiltinExec(rewrittenRe, string);

        if (!next.result) {
          break;
        }

        results.push(next.result[0]);
      }

      return {
        result: results
      };
    } else {
      //Remove g and y from regex
      var _rewrittenRe = new RegExp(regex.source, regex.flags.replace(/"g|y"/g, ""));

      return RegexpBuiltinExec(_rewrittenRe, string);
    }
  }

  function RegexpBuiltinSearch(regex, string) {
    var rewrittenRe = new RegExp(regex.source, regex.flags.replace(/g|y/g, ""));
    var test = RegexpBuiltinTest(rewrittenRe, string);
    var search_in_re = ctx.mkIte(state.asSymbolic(test.result), test.encodedRegex.startIndex, state.constantSymbol(-1));
    return {
      result: new _WrappedValue.ConcolicValue(state.getConcrete(string).search(regex), search_in_re)
    };
  }

  function RegexpBuiltinSplit(regex, string) {
    //Remove g and y from regex
    var re = new RegExp(regex.source, regex.flags.replace(/g|y/g, "") + "");
    var results = [];
    var lastIndex = 0;

    function rest() {
      return model.get(String.prototype.substring).call(string, lastIndex);
    } //While there is still a match of regex in string add the area before it to results and
    //then increase lastIndex by the size of the match + its start index


    while (true) {
      //Grab the remaining portion of the string and call exec on it
      var next = RegexpBuiltinExec(re, rest()).result; //While matches remain extract the bit before the match, add that to the result, update lastIndex and step

      if (next) {
        var matchSize = new _WrappedValue.ConcolicValue(state.getConcrete(next[0]).length, state.asSymbolic(next[0]).getLength());
        var wordsBeforeSplit = model.get(String.prototype.substring).call(string, lastIndex, next.index);
        results.push(wordsBeforeSplit);
        lastIndex = state.binary('+', lastIndex, state.binary('+', next.index, matchSize));
      } else {
        break;
      }
    } //After we have exhausted all instances of the re in string push the remainder to the result


    results.push(rest());
    return {
      result: results
    };
  }

  function RegexpBuiltinReplace(regex, string, replacementString) {
    //Remove g and y from regex
    var rewrittenRe = new RegExp(regex.source, regex.flags.replace(/g/g, "") + "");

    if (regex.flags.includes('g')) {
      var replaced = true; //Global replace

      while (true) {
        var next = RegexpBuiltinReplace(rewrittenRe, string, replacementString);

        if (!next.replaced) {
          break;
        }

        replaced = true;
        string = next.result;
      }

      return {
        result: string,
        replaced: replaced
      };
    } else {
      //Single point replace
      var _next = RegexpBuiltinExec(rewrittenRe, string).result;

      if (_next) {
        //Find out the match size
        var matchSize = new _WrappedValue.ConcolicValue(state.getConcrete(_next[0]).length, state.asSymbolic(_next[0]).getLength()); //Collect the parts before and after the match

        var lhs = model.get(String.prototype.substring).call(string, 0, _next.index);
        var rhs = model.get(String.prototype.substring).call(string, state.binary('+', _next.index, matchSize));

        if (typeof state.getConcrete(replacementString) === "function") {
          string = state.binary('+', lhs, state.binary('+', coerceToString(replacementString.apply(null, _next)), rhs));
        } else {
          var finalString; //Simple (NOT STANDARDS-COMPLAINT!!) substitution for replacement strings with things like $1, $2 in them

          if (state.getConcrete(replacementString).search(/\$[0-9]/) != -1) {
            _Log["default"].log('WARN: no support for symbolic replacement strings');

            var remaining = state.getConcrete(replacementString);
            finalString = "";
            var toreplace;

            while (toreplace = /\$[0-9]/.exec(remaining)) {
              var before = remaining.substr(0, toreplace.index);
              var _replaced = _next[toreplace[0][1]];
              finalString = state.binary('+', finalString, state.binary('+', before, _replaced));
              remaining = remaining.substr(toreplace.index + toreplace[0].length);
            }

            finalString = state.binary('+', finalString, remaining);
          } else {
            //Short circuit if there are no substitution strings
            finalString = replacementString;
          }

          string = state.binary('+', lhs, state.binary('+', finalString, rhs));
        }

        return {
          result: string,
          replaced: true
        };
      } else {
        return {
          result: string,
          replaced: false
        };
      }
    }
  }

  function shouldBeSymbolic(regex, string) {
    return regex instanceof RegExp && (state.isSymbolic(regex.lastIndex) || state.isSymbolic(string));
  }

  model.add(String.prototype.search, symbolicHookRe(String.prototype.search, function (base, args) {
    return shouldBeSymbolic(args[0], base);
  }, function (base, args) {
    return RegexpBuiltinSearch(args[0], coerceToString(base)).result;
  }));
  model.add(String.prototype.match, symbolicHookRe(String.prototype.match, function (base, args) {
    return shouldBeSymbolic(args[0], base);
  }, function (base, args) {
    return RegexpBuiltinMatch(args[0], coerceToString(base)).result;
  }));
  model.add(RegExp.prototype.exec, symbolicHookRe(RegExp.prototype.exec, function (base, args) {
    return shouldBeSymbolic(base, args[0]);
  }, function (base, args) {
    return RegexpBuiltinExec(base, coerceToString(args[0])).result;
  }));
  model.add(RegExp.prototype.test, symbolicHookRe(RegExp.prototype.test, function (base, args) {
    return shouldBeSymbolic(base, args[0]);
  }, function (base, args) {
    return RegexpBuiltinTest(base, coerceToString(args[0])).result;
  }));
  model.add(String.prototype.replace, symbolicHookRe(String.prototype.replace, function (base, args) {
    return shouldBeSymbolic(args[0], base) && (typeof state.getConcrete(args[1]) === "string" || typeof state.getConcrete(args[1]) === "function");
  }, function (base, args) {
    return RegexpBuiltinReplace(args[0], base, args[1]).result;
  }));
  model.add(String.prototype.split, symbolicHookRe(String.prototype.split, function (base, args) {
    return state.isSymbolic(base) && (args[0] instanceof RegExp || typeof args[0] === "string");
  }, function (base, args) {
    return RegexpBuiltinSplit(args[0] instanceof RegExp ? args[0] : new RegExp(args[0]), base).result;
  }));
  /**
   * Occasionally (Thanks James....) it appears developers may resolve the Symbol for the match method rather than use the API. Most interpreters use the same instance of the method for all constructs so we can add a model by creating a new RegExp, extracting the default match symbol and adding that to the models.
   */

  var Template = /DEFAULT/;
  model.add(Template[Symbol.search], symbolicHookRe(Template[Symbol.search], function (base, args) {
    return shouldBeSymbolic(base, args[0]);
  }, function (base, args) {
    return RegexpBuiltinSearch(base, coerceToString(args[0])).result;
  }));
  model.add(Template[Symbol.exec], symbolicHookRe(Template[Symbol.exec], function (base, args) {
    return shouldBeSymbolic(base, args[0]);
  }, function (base, args) {
    return RegexpBuiltinExec(base, coerceToString(args[0])).result;
  }));
  model.add(Template[Symbol.match], symbolicHookRe(Template[Symbol.match], function (base, args) {
    return shouldBeSymbolic(base, args[0]);
  }, function (base, args) {
    return RegexpBuiltinExec(base, coerceToString(args[0])).result;
  }));
  model.add(Template[Symbol.replace], symbolicHookRe(Template[Symbol.replace], function (base, args) {
    return shouldBeSymbolic(base, args[0]) && (typeof state.getConcrete(args[1]) === "string" || typeof state.getConcrete(args[1]) === "function");
  }, function (base, args) {
    return RegexpBuiltinReplace(base, args[0], args[1]).result;
  }));
}
},{"../Config":2,"../External":4,"../Utilities/Log":19,"../Values/WrappedValue":23,"z3javascript":undefined}],13:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _WrappedValue = require("../Values/WrappedValue");

var _Log = _interopRequireDefault(require("../Utilities/Log"));

var _External = _interopRequireDefault(require("../External"));

var _z3javascript = _interopRequireDefault(require("z3javascript"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var find = Array.prototype.find;

function _default(state, ctx, model, helpers) {
  var mkIndexSymbol = helpers.mkIndexSymbol;
  var symbolicHook = helpers.symbolicHook;
  var symbolicSubstring = helpers.substring;
  var coerceToString = helpers.coerceToString;
  var mkFunctionName = helpers.mkFunctionName;
  /**
   * Stubs string constructor with our (flaky) coerceToString fn
   */

  model.add(String, symbolicHook(String, function (_base, args) {
    return state.isSymbolic(args[0]);
  }, function (_base, args, _result) {
    return coerceToString(args[0]);
  }));
  var substrModel = symbolicHook(String.prototype.substr, function (base, args) {
    return typeof state.getConcrete(base) === "string" && (state.isSymbolic(base) || state.isSymbolic(args[0]) || state.isSymbolic(args[1]));
  }, symbolicSubstring);
  model.add(String.prototype.includes, symbolicHook(String.prototype.includes, function (base, args) {
    return typeof state.getConcrete(base) === "string" && state.isSymbolic(base) || state.isSymbolic(args[0]);
  }, function (base, args, result) {
    //Theory:
    //base = string, args[0] coerced to string if not string
    //If there exists some i such that substr(base, i, length args[0]) == args[0] then true
    //Otherwise false
    args[0] = coerceToString(args[0]);
    var startPosition = mkIndexSymbol('Includes_Start');
    var substringPart = ctx.mkSeqSubstr(state.asSymbolic(base), startPosition, state.asSymbolic(args[0]).getLength());
    return new _WrappedValue.ConcolicValue(result, ctx.mkEq(substringPart, state.asSymbolic(args[0])));
  }));
  model.add(String.prototype.substr, substrModel);
  model.add(String.prototype.substring, substrModel);
  model.add(String.prototype.slice, symbolicHook(String.prototype.slice, function (base, args) {
    return typeof state.getConcrete(base) === "string" && (state.isSymbolic(base) || state.isSymbolic(args[0]) || state.isSymbolic(args[1]));
  }, function (base, args, result) {
    function relativeIndex(i) {
      return new _WrappedValue.ConcolicValue(state.getConcrete(i) < 0 ? state.getConcrete(base).length - state.getConcrete(i) : state.getConcrete(i), ctx.mkIte(ctx.mkLt(state.asSymbolic(i), ctx.mkIntVal(0)), ctx.mkSub(state.asSymbolic(base).getLength(), ctx.mkMul(state.asSymbolic(i), ctx.mkIntVal(-1))), state.asSymbolic(i)));
    }

    var from = relativeIndex(args[0]);
    var to;

    if (args[1]) {
      to = relativeIndex(args[1]);
    } else {
      to = new _WrappedValue.ConcolicValue(state.getConcrete(base).length, state.asSymbolic(base).getLength());
    }

    var startIndex = ctx.mkRealToInt(state.asSymbolic(from));
    var length = ctx.mkRealToInt(state.asSymbolic(state.binary('-', to, from)));
    return new _WrappedValue.ConcolicValue(result, ctx.mkSeqSubstr(state.asSymbolic(base), startIndex, length));
  }));
  model.add(String.prototype.charAt, symbolicHook(String.prototype.charAt, function (base, args) {
    var is_symbolic = state.isSymbolic(base) || state.isSymbolic(args[0]);
    var is_well_formed = typeof state.getConcrete(base) === "string" && typeof state.getConcrete(args[0]) === "number";
    return is_symbolic && is_well_formed;
  }, function (base, args, result) {
    var index_s = ctx.mkRealToInt(state.asSymbolic(args[0]));
    var char_s = ctx.mkSeqAt(state.asSymbolic(base), index_s);
    return new _WrappedValue.ConcolicValue(result, char_s);
  }));
  model.add(String.prototype.concat, symbolicHook(String.prototype.concat, function (base, args) {
    return state.isSymbolic(base) || find.call(args, function (arg) {
      return state.isSymbolic(arg);
    });
  }, function (base, args, result) {
    var arg_s_list = Array.prototype.map.call(args, function (arg) {
      return state.asSymbolic(arg);
    });
    var concat_s = ctx.mkSeqConcat([state.asSymbolic(base)].concat(arg_s_list));
    return new _WrappedValue.ConcolicValue(result, concat_s);
  }));
  model.add(String.prototype.indexOf, symbolicHook(String.prototype.indexOf, function (base, args) {
    return typeof state.getConcrete(base) === "string" && (state.isSymbolic(base) || state.isSymbolic(args[0]) || state.isSymbolic(args[1]));
  }, function (base, args, result) {
    var off_real = args[1] ? state.asSymbolic(args[1]) : state.asSymbolic(0);
    var off_s = ctx.mkRealToInt(off_real);
    var target_s = state.asSymbolic(coerceToString(args[0]));
    var seq_index = ctx.mkSeqIndexOf(state.asSymbolic(base), target_s, off_s);
    return new _WrappedValue.ConcolicValue(result, seq_index);
  })); //TODO: Fix LastIndexOf models

  model.add(String.prototype.lastIndexOf, symbolicHook(String.prototype.lastIndexOf, function (base, args) {
    return typeof state.getConcrete(base) === "string" && (state.isSymbolic(base) || state.isSymbolic(args[0]) || state.isSymbolic(args[1]));
  }, function (base, args, result) {
    var off_real = args[1] ? state.asSymbolic(args[1]) : state.asSymbolic(0);
    var off_s = ctx.mkRealToInt(off_real);
    var target_s = state.asSymbolic(coerceToString(args[0]));
    var seq_index = ctx.mkSeqIndexOf(state.asSymbolic(base), target_s, off_s);
    return new _WrappedValue.ConcolicValue(result, seq_index);
  }));
  /*
  model.add(String.prototype.lastIndexOf, symbolicHook(
  String.prototype.lastIndexOf,
  (base, args) => typeof state.getConcrete(base) === "string" && (state.isSymbolic(base) || state.isSymbolic(args[0]) || state.isSymbolic(args[1])),
  (base, args, result) => {
       //Theory: Similar to indexOf
      //n = indexOf s p q where q == args[1] || length(base)
      //n != -1 => Not (Exists n < i < length s s.t. indexOf s t  == i)
  	  const off_real = args[1] ? state.asSymbolic(args[1]) : state.asSymbolic(base).getLength();
    const off_s = ctx.mkRealToInt(off_real);
      const actualIndex = mkIndexSymbol('LastIndexOf_Start_Position');
  	  const target_s = state.asSymbolic(coerceToString(args[0]));
    const seq_index = ctx.mkSeqIndexOf(state.asSymbolic(base), target_s, actualIndex);
        Log.log('WARN: lastIndexOf LOSS OF PRECISION does not guarentee last index');
       //Test for if there are later matches
      const intSort = ctx.mkIntSort();
      const i = ctx.mkBound(0, intSort);
      const notMatch = ctx.mkEq(ctx.mkSeqIndexOf(state.asSymbolic(base), target_s, i), ctx.mkIntVal(-1));
       const bounds = ctx.mkPattern([
          ctx.mkLt(i, state.asSymbolic(base).getLength()),
          ctx.mkGt(i, seq_index)
      ]);
  	  const noLaterMatches = ctx.mkForAll([mkFunctionName("lastIndexOf")], intSort, notMatch, [bounds]);
      state.pushCondition(noLaterMatches, true);
  	  return new ConcolicValue(result, seq_index);
  }));
  */

  model.add(String.prototype.repeat, symbolicHook(String.prototype.repeat, function (base, a) {
    return state.isSymbolic(base) || state.isSymbolic(a[0]) && typeof state.getConcrete(base) == "string" && typeof state.getConcrete(a[0]) == "number";
  }, function (base, a, result) {
    var num_repeats = state.asSymbolic(a[0]);
    state.pushCondition(ctx.mkGe(num_repeats, ctx.mkIntVal(0)));
    var result_s = ctx.mkApp(state.stringRepeat, [state.asSymbolic(base), ctx.mkRealToInt(num_repeats)]);
    return new _WrappedValue.ConcolicValue(result, result_s);
  }));

  function trimLeftSymbolic(base_s) {
    var whiteLeft = ctx.mkApp(state.whiteLeft, [base_s, ctx.mkIntVal(0)]);
    var strLen = base_s.getLength();
    var totalLength = ctx.mkSub(strLen, whiteLeft);
    return ctx.mkSeqSubstr(base_s, whiteLeft, totalLength);
  }

  function trimRightSymbolic(base_s) {
    var strLen = base_s.getLength();
    var whiteRight = ctx.mkApp(state.whiteRight, [base_s, strLen]);
    var totalLength = ctx.mkAdd(whiteRight, ctx.mkIntVal(1));
    return ctx.mkSeqSubstr(base_s, ctx.mkIntVal(0), totalLength);
  }

  model.add(String.prototype.trimRight, symbolicHook(String.prototype.trim, function (base, _a) {
    return state.isSymbolic(base) && typeof state.getConcrete(base).valueOf() === "string";
  }, function (base, _a, result) {
    var base_s = state.asSymbolic(base);
    return new _WrappedValue.ConcolicValue(result, trimRightSymbolic(base_s));
  }));
  model.add(String.prototype.trimLeft, symbolicHook(String.prototype.trim, function (base, _a) {
    return state.isSymbolic(base) && typeof state.getConcrete(base).valueOf() === "string";
  }, function (base, _a, result) {
    var base_s = state.asSymbolic(base);
    return new _WrappedValue.ConcolicValue(result, trimLeftSymbolic(base_s));
  }));
  model.add(String.prototype.trim, symbolicHook(String.prototype.trim, function (base, _a) {
    return state.isSymbolic(base) && typeof state.getConcrete(base).valueOf() === "string";
  }, function (base, _a, result) {
    var base_s = state.asSymbolic(base);
    return new _WrappedValue.ConcolicValue(result, trimRightSymbolic(trimLeftSymbolic(base_s)));
  }));
  model.add(String.prototype.toLowerCase, symbolicHook(String.prototype.toLowerCase, function (base, _a) {
    return state.isSymbolic(base) && typeof state.getConcrete(base).valueOf() === "string";
  }, function (base, _a, result) {
    base = coerceToString(base);
    state.pushCondition(ctx.mkSeqInRe(state.asSymbolic(base), _z3javascript["default"].Regex(ctx, /^[^A-Z]+$/).ast), true);
    return new _WrappedValue.ConcolicValue(result, state.asSymbolic(base));
  }));
}
},{"../External":4,"../Utilities/Log":19,"../Values/WrappedValue":23,"z3javascript":undefined}],14:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

/* Copyright (c) Royal Holloway, University of London | Contact Blake Loring (blake@parsed.uk), Duncan Mitchell (Duncan.Mitchell.2015@rhul.ac.uk), or Johannes Kinder (johannes.kinder@rhul.ac.uk) for details or support | LICENSE.md for license details */

/**
 * Thrown by the underlying script when the run should immediately terminate without an error
 */
function NotAnErrorException() {}

NotAnErrorException.prototype.toString = function () {
  return "NotAnErrorException";
};

var _default = NotAnErrorException;
exports["default"] = _default;
},{}],15:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _WrappedValue = require("./Values/WrappedValue");

var _SymbolicObject = require("./Values/SymbolicObject");

var _ObjectHelper = _interopRequireDefault(require("./Utilities/ObjectHelper"));

var _SymbolicState = _interopRequireDefault(require("./SymbolicState"));

var _Log = _interopRequireDefault(require("./Utilities/Log"));

var _NotAnErrorException = _interopRequireDefault(require("./NotAnErrorException"));

var _IsNative = require("./Utilities/IsNative");

var _Models = _interopRequireDefault(require("./Models/Models"));

var _External = _interopRequireDefault(require("./External"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var SymbolicExecution = /*#__PURE__*/function () {
  function SymbolicExecution(sandbox, initialInput, exitFn) {
    var _this = this;

    _classCallCheck(this, SymbolicExecution);

    this._sandbox = sandbox;
    this.state = new _SymbolicState["default"](initialInput, this._sandbox);
    this.models = (0, _Models["default"])(this.state);
    this._fileList = new Array();
    this._exitFn = exitFn;

    if (typeof window !== "undefined") {
      window._ExpoSE = this;
      setTimeout(function () {
        console.log("Finish timeout (callback)");

        _this.finished();

        _External["default"].close();
      }, 1000 * 60 * 1);
      var storagePool = {};

      window.localStorage.setItem = function (key, val) {
        storagePool[key] = val;
      };

      window.localStorage.getItem = function (key) {
        return storagePool[key];
      };

      console.log("Browser mode setup finished");
    } else {
      var process = _External["default"].load("process"); //Bind any uncaught exceptions to the uncaught exception handler


      process.on("uncaughtException", this._uncaughtException.bind(this)); //Bind the exit handler to the exit callback supplied

      process.on("exit", this.finished.bind(this));
    }
  }

  _createClass(SymbolicExecution, [{
    key: "finished",
    value: function finished() {
      this._exitFn(this.state, this.state.coverage);
    }
  }, {
    key: "_uncaughtException",
    value: function _uncaughtException(e) {
      //Ignore NotAnErrorException
      if (e instanceof _NotAnErrorException["default"]) {
        return;
      }

      _Log["default"].log("Uncaught exception ".concat(e, " Stack: ").concat(e.stack ? e.stack : ""));

      this.state.errors.push({
        error: "" + e,
        stack: e.stack
      });
    }
  }, {
    key: "report",
    value: function report(sourceString) {
      if (sourceString && !this.state.isSymbolic(sourceString)) {
        if (sourceString.documentURI) {
          sourceString = "" + sourceString.documentURI;
        } else if (sourceString.baseURI) {
          sourceString = "" + sourceString.baseURI;
        } else if (sourceString && sourceString.toString) {
          var tsourceString = sourceString.toString();

          if (tsourceString.includes("Object]")) {
            sourceString = _ObjectHelper["default"].asString(sourceString);
          } else {
            sourceString = tsourceString;
          }
        } else {
          sourceString = _ObjectHelper["default"].asString(sourceString);
        }
      } else {
        sourceString = this.state.asSymbolic(sourceString).simplify();
      }

      console.log("OUTPUT_LOAD_EVENT: !!!".concat(this.state.inlineToSMTLib(), "!!! !!!\"").concat(sourceString, "\"!!!"));
    }
  }, {
    key: "_reportFn",
    value: function _reportFn(f, base, args) {
      if (typeof window !== "undefined") {
        if ((f.name == "appendChild" || f.name == "prependChild" || f.name == "insertBefore" || f.name == "replaceChild") && args[0] && (args[0].src || args[0].innerHTML.includes("src="))) {
          this.report(args[0].src);
          args[0].src = this.state.getConcrete(args[0].src);
        }

        if (f.name == "open" || f.name == "fetch") {
          console.log("REPORTING FN OPEN " + JSON.stringify(args));
          this.report(args[1]);
        }
      }
    }
  }, {
    key: "invokeFunPre",
    value: function invokeFunPre(iid, f, base, args, _isConstructor, _isMethod) {
      this.state.coverage.touch(iid);
      f = this.state.getConcrete(f);

      this._reportFn(f, base, args);

      var functionName = f ? f.name : "undefined";
      var fn_model = this.models.get(f);

      /**
       * Concretize the function if it is native and we do not have a custom model for it
       * TODO: We force concretization on toString functions to avoid recursive call from the lookup into this.models
       * TODO: This is caused by getField(obj) calling obj.toString()
       * TODO: A better solution to this needs to be found
       */
      if (!fn_model && (0, _IsNative.isNative)(f)) {
        var concretized = this.state.concretizeCall(f, base, args);
        base = concretized.base;
        args = concretized.args;

        if (concretized.count > 0) {
          this.state.stats.set("Unmodeled Function Call", functionName);
        }
      } else if (fn_model) {
        this.state.stats.set("Modeled Function Call", functionName);
      } else {
        this.state.stats.seen("General Function Call");
      }
      /**
       * End of conc
       */


      return {
        f: fn_model || f,
        base: base,
        args: args,
        skip: false
      };
    }
    /**
     * Called after a function completes execution
     */

  }, {
    key: "invokeFun",
    value: function invokeFun(iid, f, base, args, result, _isConstructor, _isMethod) {
      this.state.coverage.touch(iid);
      return {
        result: result
      };
    }
  }, {
    key: "literal",
    value: function literal(iid, val, _hasGetterSetter) {
      this.state.coverage.touch(iid);
      return {
        result: val
      };
    }
  }, {
    key: "forinObject",
    value: function forinObject(iid, val) {
      this.state.coverage.touch(iid);
      return {
        result: val
      };
    }
  }, {
    key: "_location",
    value: function _location(iid) {
      return this._sandbox.iidToLocation(this._sandbox.getGlobalIID(iid));
    }
  }, {
    key: "endExpression",
    value: function endExpression(iid) {
      this.state.coverage.touch(iid);
    }
  }, {
    key: "declare",
    value: function declare(iid, name, val, _isArgument, _argumentIndex, _isCatchParam) {
      this.state.coverage.touch(iid);
      return {
        result: val
      };
    }
  }, {
    key: "getFieldPre",
    value: function getFieldPre(iid, base, offset, _isComputed, _isOpAssign, _isMethodCall) {
      this.state.coverage.touch(iid);
      return {
        base: base,
        offset: offset,
        skip: this.state.isWrapped(base) || this.state.isWrapped(offset)
      };
    }
  }, {
    key: "_getFieldSymbolicOffset",
    value: function _getFieldSymbolicOffset(base, offset) {
      offset = this.state.ToString(offset);
      var base_c = this.state.getConcrete(base);

      for (var idx in base_c) {
        var is_this_idx = this.state.binary("==", idx, offset);
        this.state.pushCondition(this.state.asSymbolic(is_this_idx));
      }
    }
    /** 
        * GetField will be skipped if the base or offset is not wrapped (SymbolicObject or isSymbolic)
        */

  }, {
    key: "getField",
    value: function getField(iid, base, offset, _val, _isComputed, _isOpAssign, _isMethodCall) {
      //TODO: This is a horrible hacky way of making certain request attributes symbolic
      //TODO: Fix this!
      if (typeof window != "undefined") {
        if (base == window.navigator) {
          if (offset == "userAgent") {
            return {
              result: Object._expose.makeSymbolic(offset, window.navigator.userAgent)
            };
          }
        }

        if (base == window.document) {
          if (offset == "cookie") {
            return {
              result: Object._expose.makeSymbolic(offset, "")
            };
          }

          if (offset == "lastModified") {
            return {
              result: Object._expose.makeSymbolic(offset, window.document.lastModified)
            };
          }

          if (offset == "referrer") {
            return {
              result: Object._expose.makeSymbolic(offset, window.document.referer)
            };
          }
        }

        if (base == window.location) {
          if (offset == "origin") {
            return {
              result: Object._expose.makeSymbolic(offset, window.location.origin)
            };
          }

          if (offset == "host") {
            return {
              result: Object._expose.makeSymbolic(offset, window.location.host)
            };
          }
        }
      }

      //If dealing with a SymbolicObject then concretize the offset and defer to SymbolicObject.getField
      if (base instanceof _SymbolicObject.SymbolicObject) {
        return {
          result: base.getField(this.state, this.state.getConcrete(offset))
        };
      } //If we are evaluating a symbolic string offset on a concrete base then enumerate all fields
      //Then return the concrete lookup


      if (!this.state.isSymbolic(base) && this.state.isSymbolic(offset) && typeof this.state.getConcrete(offset) == "string") {
        this._getFieldSymbolicOffset(base, offset);

        return {
          result: base[this.state.getConcrete(offset)]
        };
      } //If the array is a symbolic int and the base is a concrete array then enumerate all the indices


      if (!this.state.isSymbolic(base) && this.state.isSymbolic(offset) && this.state.getConcrete(base) instanceof Array && typeof this.state.getConcrete(offset) == "number") {
        for (var i = 0; i < this.state.getConcrete(base).length; i++) {
          this.state.assertEqual(i, offset);
        }

        return {
          result: base[this.state.getConcrete(offset)]
        };
      } //Otherwise defer to symbolicField


      var result_s = this.state.isSymbolic(base) ? this.state.symbolicField(this.state.getConcrete(base), this.state.asSymbolic(base), this.state.getConcrete(offset), this.state.asSymbolic(offset)) : undefined;
      var result_c = this.state.getConcrete(base)[this.state.getConcrete(offset)];
      return {
        result: result_s ? new _WrappedValue.ConcolicValue(result_c, result_s) : result_c
      };
    }
  }, {
    key: "putFieldPre",
    value: function putFieldPre(iid, base, offset, val, _isComputed, _isOpAssign) {
      this.state.coverage.touch(iid);

      if (this.state.getConcrete(offset) === "src" || this.state.getConcrete(offset) === "href") {
        this.report(val);
        val = this.state.getConcrete(val);
      }

      return {
        base: base,
        offset: offset,
        val: val,
        skip: this.state.isWrapped(base) || this.state.isWrapped(offset)
      };
    }
  }, {
    key: "putField",
    value: function putField(iid, base, offset, val, _isComputed, _isOpAssign) {
      if (base instanceof _SymbolicObject.SymbolicObject) {
        return {
          result: base.setField(this.state, this.state.getConcrete(offset), val)
        };
      } //TODO: Enumerate if symbolic offset and concrete input


      if (this.state.isSymbolic(base) && this.state.getConcrete(base) instanceof Array && this.state.arrayType(base) == _typeof(val)) {
        _Log["default"].log("TODO: Check that setField is homogonous"); //SetField produce a new array
        //Therefore the symbolic portion of base needs to be updated


        var base_s = this.state.asSymbolic(base).setField(this.state.asSymbolic(offset), this.state.asSymbolic(val));
        this.state.getConcrete(base)[this.state.getConcrete(offset)] = val;
        this.state.updateSymbolic(base, base_s);

        if (typeof document !== "undefined" && this.state.getConcrete(base) instanceof Element && document.contains(this.state.getConcrete(base)) && offset === "innerHTML") {
          var tv = this.state.getConcrete(val);

          if (typeof tv === "string" && tv.includes("src=")) {
            var sourceString = this.state.asSymbolic(val).toString();
            this.report(sourceString);
          }
        }

        return {
          result: val
        };
      }

      this.state.getConcrete(base)[this.state.getConcrete(offset)] = val;
      return {
        result: val
      };
    }
  }, {
    key: "read",
    value: function read(iid, name, val, _isGlobal, _isScriptLocal) {
      this.state.coverage.touch(iid);
      return {
        result: val
      };
    }
  }, {
    key: "write",
    value: function write(iid, name, val, _lhs, _isGlobal, _isScriptLocal) {
      this.state.coverage.touch(iid);
      return {
        result: val
      };
    }
  }, {
    key: "_return",
    value: function _return(iid, val) {
      this.state.coverage.touch(iid);
      return {
        result: val
      };
    }
  }, {
    key: "_throw",
    value: function _throw(iid, val) {
      this.state.coverage.touch(iid);
      return {
        result: val
      };
    }
  }, {
    key: "_with",
    value: function _with(iid, val) {
      this.state.coverage.touch(iid);
      return {
        result: val
      };
    }
  }, {
    key: "functionEnter",
    value: function functionEnter(iid, f, _dis, _args) {
      this.state.coverage.touch(iid);
    }
  }, {
    key: "functionExit",
    value: function functionExit(iid, returnVal, wrappedExceptionVal) {
      this.state.coverage.touch(iid);
      return {
        returnVal: returnVal,
        wrappedExceptionVal: wrappedExceptionVal,
        isBacktrack: false
      };
    }
  }, {
    key: "_scriptDepth",
    value: function _scriptDepth() {
      return this._fileList.length;
    }
  }, {
    key: "_addScript",
    value: function _addScript(fd) {
      this._fileList.push(fd);
    }
  }, {
    key: "_removeScript",
    value: function _removeScript() {
      return this._fileList.pop();
    }
  }, {
    key: "scriptEnter",
    value: function scriptEnter(iid, instrumentedFileName, originalFileName) {
      //this.state.coverage.touch(iid);
      var enterString = "====== ENTERING SCRIPT ".concat(originalFileName, " depth ").concat(this._scriptDepth(), " ======");

      if (this._scriptDepth() == 0) {
        _Log["default"].log(enterString);
      } else {}

      this._addScript(originalFileName);
    }
  }, {
    key: "scriptExit",
    value: function scriptExit(iid, wrappedExceptionVal) {
      //this.state.coverage.touch(iid);
      var originalFileName = this._removeScript();

      var exitString = "====== EXITING SCRIPT ".concat(originalFileName, " depth ").concat(this._scriptDepth(), " ======");

      if (this._scriptDepth() > 0) {} else {
        _Log["default"].log(exitString);
      }

      return {
        wrappedExceptionVal: wrappedExceptionVal,
        isBacktrack: false
      };
    }
  }, {
    key: "binaryPre",
    value: function binaryPre(iid, op, left, right, _isOpAssign, _isSwitchCaseComparison, _isComputed) {
      //Don't do symbolic logic if the symbolic values are diff types
      //Concretise instead
      if (this.state.isWrapped(left) || this.state.isWrapped(right)) {
        var left_c = this.state.getConcrete(left);
        var right_c = this.state.getConcrete(right); //We also consider boxed primitives to be primitive

        var is_primative = _typeof(left_c) != "object" || left_c instanceof Number || left_c instanceof String || left_c instanceof Boolean;
        var is_null = left_c === undefined || right_c === undefined || left_c === null || right_c === null;
        var is_real = typeof left_c == "number" ? Number.isFinite(left_c) && Number.isFinite(right_c) : true; //TODO: Work out how to check that boxed values are the same type

        var is_same_type = _typeof(left_c) === _typeof(right_c) || !is_null && left_c.valueOf() === right_c.valueOf();

        if (!is_same_type || !is_primative || is_null || !is_real) {
          _Log["default"].log("Concretizing binary ".concat(op, " on operands of differing types. Type coercion not yet implemented symbolically. (").concat(_ObjectHelper["default"].asString(left_c), ", ").concat(_ObjectHelper["default"].asString(right_c), ") (").concat(_typeof(left_c), ", ").concat(_typeof(right_c), ")"));

          left = left_c;
          right = right_c;
        } else {}
      } // Don't evaluate natively when args are symbolic


      return {
        op: op,
        left: left,
        right: right,
        skip: this.state.isWrapped(left) || this.state.isWrapped(right)
      };
    }
  }, {
    key: "binary",
    value: function binary(iid, op, left, right, result_c, _isOpAssign, _isSwitchCaseComparison, _isComputed) {
      this.state.coverage.touch(iid);
      var result;

      if (this.state.isSymbolic(left) || this.state.isSymbolic(right)) {
        result = this.state.binary(op, left, right);
      } else {
        result = result_c;
      }

      return {
        result: result
      };
    }
  }, {
    key: "unaryPre",
    value: function unaryPre(iid, op, left) {
      // Don't evaluate natively when args are symbolic
      return {
        op: op,
        left: left,
        skip: this.state.isWrapped(left)
      };
    }
  }, {
    key: "unary",
    value: function unary(iid, op, left, result_c) {
      this.state.coverage.touch(iid);
      return {
        result: this.state.unary(op, left)
      };
    }
  }, {
    key: "conditional",
    value: function conditional(iid, result) {
      this.state.coverage.touch_cnd(iid, this.state.getConcrete(result));

      if (this.state.isSymbolic(result)) {
        this.state.conditional(this.state.toBool(result));
      }

      return {
        result: this.state.getConcrete(result)
      };
    }
  }, {
    key: "instrumentCodePre",
    value: function instrumentCodePre(iid, code) {
      return {
        code: code,
        skip: false
      };
    }
  }, {
    key: "instrumentCode",
    value: function instrumentCode(iid, code, _newAst) {
      return {
        result: code
      };
    }
    /*runInstrumentedFunctionBody(iid) {}*/

  }, {
    key: "onReady",
    value: function onReady(cb) {
      cb();
    }
  }]);

  return SymbolicExecution;
}();

var _default = SymbolicExecution;
exports["default"] = _default;
},{"./External":4,"./Models/Models":11,"./NotAnErrorException":14,"./SymbolicState":17,"./Utilities/IsNative":18,"./Utilities/Log":19,"./Utilities/ObjectHelper":20,"./Values/SymbolicObject":22,"./Values/WrappedValue":23}],16:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof2(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof2 = function _typeof2(obj) { return typeof obj; }; } else { _typeof2 = function _typeof2(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof2(obj); }

/* Copyright (c) Royal Holloway, University of London | Contact Blake Loring (blake@parsed.uk), Duncan Mitchell (Duncan.Mitchell.2015@rhul.ac.uk), or Johannes Kinder (johannes.kinder@rhul.ac.uk) for details or support | LICENSE.md for license details */
var BinaryJumpTable = {
  "==": function _(left, right) {
    return left == right;
  },
  "===": function _(left, right) {
    return left === right;
  },
  "!=": function _(left, right) {
    return left != right;
  },
  "!==": function _(left, right) {
    return left !== right;
  },
  "<": function _(left, right) {
    return left < right;
  },
  ">": function _(left, right) {
    return left > right;
  },
  "<=": function _(left, right) {
    return left <= right;
  },
  ">=": function _(left, right) {
    return left >= right;
  },
  "+": function _(left, right) {
    return left + right;
  },
  "-": function _(left, right) {
    return left - right;
  },
  "*": function _(left, right) {
    return left * right;
  },
  "/": function _(left, right) {
    return left / right;
  },
  "%": function _(left, right) {
    return left % right;
  },
  ">>": function _(left, right) {
    return left >> right;
  },
  "<<": function _(left, right) {
    return left << right;
  },
  ">>>": function _(left, right) {
    return left >>> right;
  },
  "&": function _(left, right) {
    return left & right;
  },
  "&&": function _(left, right) {
    return left && right;
  },
  "|": function _(l, r) {
    return l | r;
  },
  "||": function _(l, r) {
    return l || r;
  },
  "^": function _(l, r) {
    return l ^ r;
  },
  "instanceof": function _instanceof(l, r) {
    return l instanceof r;
  },
  "in": function _in(l, r) {
    return l in r;
  }
};
var UnaryJumpTable = {
  "!": function _(v) {
    return !v;
  },
  "~": function _(v) {
    return ~v;
  },
  "-": function _(v) {
    return -v;
  },
  "+": function _(v) {
    return +v;
  },
  "typeof": function _typeof(v) {
    return _typeof2(v);
  }
};
var _default = {
  evalBinary: function evalBinary(op, left, right) {
    return BinaryJumpTable[op](left, right);
  },
  evalUnary: function evalUnary(op, left) {
    return UnaryJumpTable[op](left);
  }
};
exports["default"] = _default;
},{}],17:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Log = _interopRequireDefault(require("./Utilities/Log"));

var _ObjectHelper = _interopRequireDefault(require("./Utilities/ObjectHelper"));

var _Coverage = _interopRequireDefault(require("./Coverage"));

var _Config = _interopRequireDefault(require("./Config"));

var _SymbolicHelper = _interopRequireDefault(require("./SymbolicHelper"));

var _SymbolicObject = require("./Values/SymbolicObject");

var _WrappedValue = require("./Values/WrappedValue");

var _Stats = _interopRequireDefault(require("Stats"));

var _z3javascript = _interopRequireDefault(require("z3javascript"));

var _Helpers = _interopRequireDefault(require("./Models/Helpers"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function BuildUnaryJumpTable(state) {
  var ctx = state.ctx;
  return {
    "boolean": {
      "+": function _(val_s) {
        return ctx.mkIte(val_s, state.constantSymbol(1), state.constantSymbol(0));
      },
      "-": function _(val_s) {
        return ctx.mkIte(val_s, state.constantSymbol(-1), state.constantSymbol(0));
      },
      "!": function _(val_s) {
        return ctx.mkNot(val_s);
      }
    },
    "number": {
      "!": function _(val_s, val_c) {
        var bool_s = state.asSymbolic(state.toBool(new _WrappedValue.ConcolicValue(val_c, val_s)));
        return bool_s ? ctx.mkNot(bool_s) : undefined;
      },
      "+": function _(val_s) {
        return val_s;
      },
      "-": function _(val_s) {
        return ctx.mkUnaryMinus(val_s);
      }
    },
    "string": {
      "!": function _(val_s, val_c) {
        var bool_s = state.asSymbolic(state.toBool(new _WrappedValue.ConcolicValue(val_c, val_s)));
        return bool_s ? ctx.mkNot(bool_s) : undefined;
      },
      "+": function _(val_s) {
        return ctx.mkStrToInt(val_s);
      },
      "-": function _(val_s) {
        return ctx.mkUnaryMinus(ctx.mkStrToInt(val_s));
      }
    }
  };
}

var SymbolicState = /*#__PURE__*/function () {
  function SymbolicState(input, sandbox) {
    _classCallCheck(this, SymbolicState);

    this.ctx = new _z3javascript["default"].Context();
    this.slv = new _z3javascript["default"].Solver(this.ctx, _Config["default"].incrementalSolverEnabled, [{
      name: "smt.string_solver",
      value: _Config["default"].stringSolver
    }, //				{ name: "timeout", value: Config.maxSolverTime },
    {
      name: "random_seed",
      value: Math.floor(Math.random() * Math.pow(2, 32))
    }, {
      name: "phase_selection",
      value: 5
    }]);
    this.helpers = new _Helpers["default"](this, this.ctx);
    _z3javascript["default"].Query.MAX_REFINEMENTS = _Config["default"].maxRefinements;
    this.input = input;
    this.inputSymbols = {};
    this.pathCondition = [];
    this.stats = new _Stats["default"]();
    this.coverage = new _Coverage["default"](sandbox);
    this.errors = [];
    this._unaryJumpTable = BuildUnaryJumpTable(this);

    this._setupSmtFunctions();
  }
  /** Set up a bunch of SMT functions used by the models **/


  _createClass(SymbolicState, [{
    key: "_setupSmtFunctions",
    value: function _setupSmtFunctions() {
      this.stringRepeat = this.ctx.mkRecFunc(this.ctx.mkStringSymbol("str.repeat"), [this.ctx.mkStringSort(), this.ctx.mkIntSort()], this.ctx.mkStringSort());
      this.slv.fromString("(define-fun-rec str.repeat ((a String) (b Int)) String (if (<= b 0) \"\" (str.++ a (str.repeat a (- b 1)))))");
      this.whiteLeft = this.ctx.mkRecFunc(this.ctx.mkStringSymbol("str.whiteLeft"), [this.ctx.mkStringSort(), this.ctx.mkIntSort()], this.ctx.mkIntSort());
      this.whiteRight = this.ctx.mkRecFunc(this.ctx.mkStringSymbol("str.whiteRight"), [this.ctx.mkStringSort(), this.ctx.mkIntSort()], this.ctx.mkIntSort());
      /** Set up trim methods **/

      this.slv.fromString("(define-fun str.isWhite ((c String)) Bool (= c \" \"))\n" + //TODO: Only handles  
      "(define-fun-rec str.whiteLeft ((s String) (i Int)) Int (if (str.isWhite (str.at s i)) (str.whiteLeft s (+ i 1)) i))\n" + "(define-fun-rec str.whiteRight ((s String) (i Int)) Int (if (str.isWhite (str.at s i)) (str.whiteRight s (- i 1)) i))\n");
    }
  }, {
    key: "pushCondition",
    value: function pushCondition(cnd, binder) {
      this.pathCondition.push({
        ast: cnd,
        binder: binder || false,
        forkIid: this.coverage.last()
      });
    }
  }, {
    key: "conditional",
    value: function conditional(result) {
      var result_c = this.getConcrete(result),
          result_s = this.asSymbolic(result);

      if (result_c === true) {
        this.pushCondition(result_s);
      } else if (result_c === false) {
        this.pushCondition(this.ctx.mkNot(result_s));
      } else {
        _Log["default"].log("WARNING: Symbolic Conditional on non-bool, concretizing");
      }

      return result_c;
    }
    /**
      * Creates a full (up to date) solver instance and then calls toString on it to create an SMT2Lib problem
      * TODO: This is a stop-gag implementation for the work with Ronny - not to be relied upon.
      */

  }, {
    key: "inlineToSMTLib",
    value: function inlineToSMTLib() {
      var _this = this;

      this.slv.push();
      this.pathCondition.forEach(function (pcItem) {
        return _this.slv.assert(pcItem.ast);
      });
      var resultString = this.slv.toString();
      this.slv.pop();
      return resultString;
    }
    /**
       * Returns the final PC as a string (if any symbols exist)
       */

  }, {
    key: "finalPC",
    value: function finalPC() {
      return this.pathCondition.filter(function (x) {
        return x.ast;
      }).map(function (x) {
        return x.ast;
      });
    }
  }, {
    key: "_stringPC",
    value: function _stringPC(pc) {
      return pc.length ? pc.reduce(function (prev, current) {
        var this_line = current.simplify().toPrettyString().replace(/\s+/g, " ").replace(/not /g, "¬");

        if (this_line.startsWith("(¬")) {
          this_line = this_line.substr(1, this_line.length - 2);
        }

        if (this_line == "true" || this_line == "false") {
          return prev;
        } else {
          return prev + (prev.length ? ", " : "") + this_line;
        }
      }, "") : "";
    }
  }, {
    key: "_addInput",
    value: function _addInput(pc, solution, pcIndex, childInputs) {
      solution._bound = pcIndex + 1;
      childInputs.push({
        input: solution,
        pc: this._stringPC(pc),
        forkIid: this.pathCondition[pcIndex].forkIid
      });
    }
  }, {
    key: "_buildPC",
    value: function _buildPC(childInputs, i, inputCallback) {
      var newPC = this.ctx.mkNot(this.pathCondition[i].ast);
      var allChecks = this.pathCondition.slice(0, i).reduce(function (last, next) {
        return last.concat(next.ast.checks);
      }, []).concat(newPC.checks);

      var solution = this._checkSat(newPC, i, allChecks);

      if (solution) {
        this._addInput(newPC, solution, i, childInputs);

        if (inputCallback) {
          inputCallback(childInputs);
        }
      } else {}
    }
  }, {
    key: "_buildAsserts",
    value: function _buildAsserts(i) {
      return this.pathCondition.slice(0, i).map(function (x) {
        return x.ast;
      });
    }
  }, {
    key: "alternatives",
    value: function alternatives(inputCallback) {
      var _this2 = this;

      var childInputs = [];

      if (this.input._bound > this.pathCondition.length) {
        throw "Bound ".concat(this.input._bound, " > ").concat(this.pathCondition.length, ", divergence has occured");
      } //Push all PCs up until bound


      this._buildAsserts(Math.min(this.input._bound, this.pathCondition.length)).forEach(function (x) {
        return _this2.slv.assert(x);
      });

      this.slv.push();

      for (var i = this.input._bound; i < this.pathCondition.length; i++) {
        //TODO: Make checks on expressions smarter
        if (!this.pathCondition[i].binder) {
          this._buildPC(childInputs, i, inputCallback);
        }

        //Push the current thing we're looking at to the solver
        this.slv.assert(this.pathCondition[i].ast);
        this.slv.push();
      }

      this.slv.reset(); //Guarentee inputCallback is called at least once

      inputCallback(childInputs);
    }
  }, {
    key: "_getSort",
    value: function _getSort(concrete) {
      var sort;

      switch (_typeof(concrete)) {
        case "boolean":
          sort = this.ctx.mkBoolSort();
          break;

        case "number":
          sort = this.ctx.mkRealSort();
          break;

        case "string":
          sort = this.ctx.mkStringSort();
          break;

        default:
          _Log["default"].log("Symbolic input variable of type ".concat(typeof val === "undefined" ? "undefined" : _typeof(val), " not yet supported."));

      }

      return sort;
    }
  }, {
    key: "_deepConcrete",
    value: function _deepConcrete(start, _concreteCount) {
      start = this.getConcrete(start);
      /*
      let worklist = [this.getConcrete(start)];
      let seen = [];
      	while (worklist.length) {
      	const arg = worklist.pop();
      	seen.push(arg);
      		for (let i in arg) {
      		if (this.isSymbolic(arg[i])) {
      			arg[i] = this.getConcrete(arg[i]);
      			concreteCount.val += 1;
      		}
      			const seenBefore = !!seen.find(x => x === arg); 
      		if (arg[i] instanceof Object && !seenBefore) {
      			worklist.push(arg[i]); 
      		}
      	}
      }
        */

      return start;
    }
  }, {
    key: "concretizeCall",
    value: function concretizeCall(f, base, args) {
      var report = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
      var numConcretizedProperties = {
        val: 0
      };
      base = this._deepConcrete(base, numConcretizedProperties);
      var n_args = Array(args.length);

      for (var i = 0; i < args.length; i++) {
        n_args[i] = this._deepConcrete(args[i], numConcretizedProperties);
      }

      if (report && numConcretizedProperties.val) {
        this.stats.set("Concretized Function Calls", f.name);
      }

      return {
        base: base,
        args: n_args,
        count: numConcretizedProperties.val
      };
    }
  }, {
    key: "createPureSymbol",
    value: function createPureSymbol(name) {
      this.stats.seen("Pure Symbols");
      var pureType = this.createSymbolicValue(name + "_t", "undefined");
      var res;

      if (this.assertEqual(pureType, this.concolic("string"))) {
        res = this.createSymbolicValue(name, "seed_string");
      } else if (this.assertEqual(pureType, this.concolic("number"))) {
        res = this.createSymbolicValue(name, 0);
      } else if (this.assertEqual(pureType, this.concolic("boolean"))) {
        res = this.createSymbolicValue(name, false);
      } else if (this.assertEqual(pureType, this.concolic("object"))) {
        res = this.createSymbolicValue(name, {});
      } else if (this.assertEqual(pureType, this.concolic("array_number"))) {
        res = this.createSymbolicValue(name, [0]);
      } else if (this.assertEqual(pureType, this.concolic("array_string"))) {
        res = this.createSymbolicValue(name, [""]);
      } else if (this.assertEqual(pureType, this.concolic("array_bool"))) {
        res = this.createSymbolicValue(name, [false]);
      } else if (this.assertEqual(pureType, this.concolic("null"))) {
        res = null;
      } else {
        res = undefined;
      }

      return res;
    }
    /**
        * TODO: Symbol Renaming internalization
        */

  }, {
    key: "createSymbolicValue",
    value: function createSymbolicValue(name, concrete) {
      this.stats.seen("Symbolic Values"); //TODO: Very ugly short circuit

      if (!(concrete instanceof Array) && _typeof(concrete) === "object") {
        return new _SymbolicObject.SymbolicObject(name);
      }

      var symbolic;
      var arrayType;

      if (concrete instanceof Array) {
        this.stats.seen("Symbolic Arrays");
        symbolic = this.ctx.mkArray(name, this._getSort(concrete[0]));
        this.pushCondition(this.ctx.mkGe(symbolic.getLength(), this.ctx.mkIntVal(0)), true);
        arrayType = _typeof(concrete[0]);
      } else {
        this.stats.seen("Symbolic Primitives");

        var sort = this._getSort(concrete);

        var symbol = this.ctx.mkStringSymbol(name);
        symbolic = this.ctx.mkConst(symbol, sort);
      } // Use generated input if available


      if (name in this.input) {
        concrete = this.input[name];
      } else {
        this.input[name] = concrete;
      }

      this.inputSymbols[name] = symbolic;
      return new _WrappedValue.ConcolicValue(concrete, symbolic, arrayType);
    }
  }, {
    key: "getSolution",
    value: function getSolution(model) {
      var solution = {};

      for (var name in this.inputSymbols) {
        var solutionAst = model.eval(this.inputSymbols[name]);
        solution[name] = solutionAst.asConstant(model);
        solutionAst.destroy();
      }

      model.destroy();
      return solution;
    }
  }, {
    key: "_checkSat",
    value: function _checkSat(clause, i, checks) {
      var startTime = new Date().getTime();
      var model = new _z3javascript["default"].Query([clause], checks).getModel(this.slv);
      var endTime = new Date().getTime();
      this.stats.max("Max Queries (Any)", _z3javascript["default"].Query.LAST_ATTEMPTS);

      if (model) {
        this.stats.max("Max Queries (Succesful)", _z3javascript["default"].Query.LAST_ATTEMPTS);
      } else {
        this.stats.seen("Failed Queries");

        if (_z3javascript["default"].Query.LAST_ATTEMPTS == _z3javascript["default"].Query.MAX_REFINEMENTS) {
          this.stats.seen("Failed Queries (Max Refinements)");
        }
      }

      _Log["default"].logQuery(clause.toString(), this.slv.toString(), checks.length, startTime, endTime, model ? model.toString() : undefined, _z3javascript["default"].Query.LAST_ATTEMPTS, _z3javascript["default"].Query.LAST_ATTEMPTS == _z3javascript["default"].Query.MAX_REFINEMENTS);

      return model ? this.getSolution(model) : undefined;
    }
  }, {
    key: "isWrapped",
    value: function isWrapped(val) {
      return val instanceof _WrappedValue.WrappedValue;
    }
  }, {
    key: "isSymbolic",
    value: function isSymbolic(val) {
      return !!_WrappedValue.ConcolicValue.getSymbolic(val);
    }
  }, {
    key: "updateSymbolic",
    value: function updateSymbolic(val, val_s) {
      return _WrappedValue.ConcolicValue.setSymbolic(val, val_s);
    }
  }, {
    key: "getConcrete",
    value: function getConcrete(val) {
      return val instanceof _WrappedValue.WrappedValue ? val.getConcrete() : val;
    }
  }, {
    key: "arrayType",
    value: function arrayType(val) {
      return val instanceof _WrappedValue.WrappedValue ? val.getArrayType() : undefined;
    }
  }, {
    key: "getSymbolic",
    value: function getSymbolic(val) {
      return _WrappedValue.ConcolicValue.getSymbolic(val);
    }
  }, {
    key: "asSymbolic",
    value: function asSymbolic(val) {
      return _WrappedValue.ConcolicValue.getSymbolic(val) || this.constantSymbol(val);
    }
  }, {
    key: "_symbolicBinary",
    value: function _symbolicBinary(op, left_c, left_s, right_c, right_s) {
      this.stats.seen("Symbolic Binary");

      switch (op) {
        case "===":
        case "==":
          return this.ctx.mkEq(left_s, right_s);

        case "!==":
        case "!=":
          return this.ctx.mkNot(this.ctx.mkEq(left_s, right_s));

        case "&&":
          return this.ctx.mkAnd(left_s, right_s);

        case "||":
          return this.ctx.mkOr(left_s, right_s);

        case ">":
          return this.ctx.mkGt(left_s, right_s);

        case ">=":
          return this.ctx.mkGe(left_s, right_s);

        case "<=":
          return this.ctx.mkLe(left_s, right_s);

        case "<":
          return this.ctx.mkLt(left_s, right_s);

        case "<<":
        case "<<<":
          left_s = this.ctx.mkRealToInt(left_s);
          right_s = this.ctx.mkRealToInt(right_s);
          return this.ctx.mkIntToReal(this.ctx.mkMul(left_s, this.ctx.mkPower(this.ctx.mkIntVal(2), right_s)));

        case ">>":
        case ">>>":
          left_s = this.ctx.mkRealToInt(left_s);
          right_s = this.ctx.mkRealToInt(right_s);
          return this.ctx.mkIntToReal(this.ctx.mkDiv(left_s, this.ctx.mkPower(this.ctx.mkIntVal(2), right_s)));

        case "+":
          return typeof left_c === "string" ? this.ctx.mkSeqConcat([left_s, right_s]) : this.ctx.mkAdd(left_s, right_s);

        case "-":
          return this.ctx.mkSub(left_s, right_s);

        case "*":
          return this.ctx.mkMul(left_s, right_s);

        case "/":
          return this.ctx.mkDiv(left_s, right_s);

        case "%":
          return this.ctx.mkMod(left_s, right_s);

        default:
          _Log["default"].log("Symbolic execution does not support operand ".concat(op, ", concretizing."));

          break;
      }

      return undefined;
    }
    /** 
      * Symbolic binary operation, expects two concolic values and an operator
      */

  }, {
    key: "binary",
    value: function binary(op, left, right) {
      if (typeof this.getConcrete(left) === "string") {
        right = this.ToString(right);
      }

      var result_c = _SymbolicHelper["default"].evalBinary(op, this.getConcrete(left), this.getConcrete(right));

      var result_s = this._symbolicBinary(op, this.getConcrete(left), this.asSymbolic(left), this.getConcrete(right), this.asSymbolic(right));

      return _typeof(result_s) !== undefined ? new _WrappedValue.ConcolicValue(result_c, result_s) : result_c;
    }
    /**
      * Symbolic field lookup - currently only has support for symbolic arrays / strings
      */

  }, {
    key: "symbolicField",
    value: function symbolicField(base_c, base_s, field_c, field_s) {
      this.stats.seen("Symbolic Field");

      function canHaveFields() {
        return typeof base_c === "string" || base_c instanceof Array;
      }

      function isRealNumber() {
        return typeof field_c === "number" && Number.isFinite(field_c);
      }

      if (canHaveFields() && isRealNumber()) {
        var withinBounds = this.ctx.mkAnd(this.ctx.mkGt(field_s, this.ctx.mkIntVal(-1)), this.ctx.mkLt(field_s, base_s.getLength()));

        if (this.conditional(new _WrappedValue.ConcolicValue(field_c > -1 && field_c < base_c.length, withinBounds))) {
          return base_s.getField(this.ctx.mkRealToInt(field_s));
        } else {
          return undefined;
        }
      }

      switch (field_c) {
        case "length":
          {
            if (base_s.getLength()) {
              return base_s.getLength();
            } else {
              _Log["default"].log("No length field on symbolic value");
            }

            break;
          }

        default:
          {
            _Log["default"].log("Unsupported symbolic field - concretizing " + base_c + " and field " + field_c);

            break;
          }
      }

      return undefined;
    }
    /**
        * Coerce either a concrete or ConcolicValue to a boolean
        * Concretizes the ConcolicValue if no coercion rule is known
        */

  }, {
    key: "toBool",
    value: function toBool(val) {
      if (this.isSymbolic(val)) {
        var val_type = _typeof(this.getConcrete(val));

        switch (val_type) {
          case "boolean":
            return val;

          case "number":
            return this.binary("!=", val, this.concolic(0));

          case "string":
            return this.binary("!=", val, this.concolic(""));
        }

        _Log["default"].log("WARNING: Concretizing coercion to boolean (toBool) due to unknown type");
      }

      return this.getConcrete(!!val);
    }
    /**
        * Perform a symbolic unary action.
        * Expects an Expr and returns an Expr or undefined if we don't
        * know how to do this op symbolically
        */

  }, {
    key: "_symbolicUnary",
    value: function _symbolicUnary(op, left_c, left_s) {
      this.stats.seen("Symbolic Unary");
      var unaryFn = this._unaryJumpTable[_typeof(left_c)] ? this._unaryJumpTable[_typeof(left_c)][op] : undefined;

      if (unaryFn) {
        return unaryFn(left_s, left_c);
      } else {
        _Log["default"].log("Unsupported symbolic operand: ".concat(op, " on ").concat(left_c, " symbolic ").concat(left_s));

        return undefined;
      }
    }
  }, {
    key: "ToString",
    value: function ToString(symbol) {
      if (typeof this.getConcrete(symbol) !== "string") {
        _Log["default"].log("TODO: Concretizing non string input ".concat(symbol, " reduced to ").concat(this.getConcrete(symbol)));

        return "" + this.getConcrete(symbol);
      }

      return symbol;
    }
    /**
        * Perform a unary op on a ConcolicValue or a concrete value
        * Concretizes the ConcolicValue if we don't know how to do that action symbolically
        */

  }, {
    key: "unary",
    value: function unary(op, left) {
      var result_c = _SymbolicHelper["default"].evalUnary(op, this.getConcrete(left));

      var result_s = this.isSymbolic(left) ? this._symbolicUnary(op, this.getConcrete(left), this.asSymbolic(left)) : undefined;
      return result_s ? new _WrappedValue.ConcolicValue(result_c, result_s) : result_c;
    }
    /**
        * Return a symbol which will always be equal to the constant value val
        * returns undefined if the theory is not supported.
        */

  }, {
    key: "constantSymbol",
    value: function constantSymbol(val) {
      this.stats.seen("Wrapped Constants");

      if (val && _typeof(val) === "object") {
        val = val.valueOf();
      }

      switch (_typeof(val)) {
        case "boolean":
          return val ? this.ctx.mkTrue() : this.ctx.mkFalse();

        case "number":
          return Math.round(val) === val ? this.ctx.mkReal(val, 1) : this.ctx.mkNumeral("" + val, this.ctx.mkRealSort());

        case "string":
          return this.ctx.mkString(val.toString());

        default:
          _Log["default"].log("Symbolic expressions with " + _typeof(val) + " literals not yet supported.");

      }

      return undefined;
    }
    /**
        * If val is a symbolic value then return val otherwise wrap it
        * with a constant symbol inside a ConcolicValue.
        *
        * Used to turn a concrete value into a constant symbol for symbolic ops.
        */

  }, {
    key: "concolic",
    value: function concolic(val) {
      return this.isSymbolic(val) ? val : new _WrappedValue.ConcolicValue(val, this.constantSymbol(val));
    }
    /**
        * Assert left == right on the path condition
        */

  }, {
    key: "assertEqual",
    value: function assertEqual(left, right) {
      var equalityTest = this.binary("==", left, right);
      this.conditional(equalityTest);
      return this.getConcrete(equalityTest);
    }
  }]);

  return SymbolicState;
}();

var _default = SymbolicState;
exports["default"] = _default;
},{"./Config":2,"./Coverage":3,"./Models/Helpers":8,"./SymbolicHelper":16,"./Utilities/Log":19,"./Utilities/ObjectHelper":20,"./Values/SymbolicObject":22,"./Values/WrappedValue":23,"Stats":26,"z3javascript":undefined}],18:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isNative = isNative;

var _Log = _interopRequireDefault(require("./Log"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/** 
 * Some code is from https://gist.github.com/jdalton/5e34d890105aca44399f by John-David Dalton
 */
var toString = Object.prototype.toString;
var fnToString = Function.prototype.toString;
var reHostCtor = /^\[object .+?Constructor\]$/;
var SECRET_CACHE_STR = "__checked_isNative__before__";
var reNative = RegExp("^" + String(toString).replace(/[.*+?^${}()|[\]\/\\]/g, "\\$&").replace(/toString|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");

function isNativeCore(value) {
  if (value.hasOwnProperty('toString')) {
    _Log["default"].log('WARNING: IsNative will not work on custom toString methods. We assume nobody would overwrite core method toStrings');

    return false;
  }

  if (typeof value === "function") {
    return reNative.test(fnToString.call(value));
  } else if (_typeof(value) === "object") {
    return reHostCtor.test(toString.call(value));
  } else {
    return false;
  }
}

function isNative(v) {
  var type = _typeof(v);

  if (v === null || v === undefined) {
    return false;
  }

  if (typeof v === "function" || _typeof(v) === "object") {
    return isNativeCore(v);
  } else {
    return false;
  }
}
},{"./Log":19}],19:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Config = _interopRequireDefault(require("../Config"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var fs = require("fs");

function makeid(count) {
  var text = "";
  var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

  for (var i = 0; i < count; i++) {
    text += possible.charAt(Math.floor(Math.random() * possible.length));
  }

  return text;
}

var path_dump_id = makeid(4);
var log_path = console.log;
/**
 * Class to handle logging
 * Structured this way for historical reasons, unneeded 
 * logs are now removed at compile for performance
 */

var Log = /*#__PURE__*/function () {
  function Log() {
    _classCallCheck(this, Log);
  }

  _createClass(Log, [{
    key: "logHigh",
    value: function logHigh(msg) {
      log_path("[?] " + msg);
    }
  }, {
    key: "logMid",
    value: function logMid(msg) {
      log_path("[?] " + msg);
    }
  }, {
    key: "log",
    value: function log(msg) {
      log_path("[!] " + msg);
    }
  }, {
    key: "logQuery",
    value: function logQuery(clause, solver, checkCount, startTime, endTime, model, attempts, hitMax) {
      if (!_Config["default"].outQueriesDir) {
        return;
      }

      var dumpData = {
        clause: clause,
        model: model,
        attempts: attempts,
        startTime: startTime,
        endTime: endTime,
        hitMaxRefinements: hitMax,
        checkCount: checkCount,
        containedRe: (solver + clause).includes("str.in.re")
      };
      var dumpFileName = _Config["default"].outQueriesDir + "/" + path_dump_id;
      fs.appendFileSync(dumpFileName, JSON.stringify(dumpData) + "\nEXPOSE_QUERY_DUMP_SEPERATOR\n");
      this.log("Wrote ".concat(dumpFileName));
    }
  }]);

  return Log;
}();

var _default = new Log();

exports["default"] = _default;
},{"../Config":2,"fs":24}],20:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/* Copyright (c) Royal Holloway, University of London | Contact Blake Loring (blake@parsed.uk), Duncan Mitchell (Duncan.Mitchell.2015@rhul.ac.uk), or Johannes Kinder (johannes.kinder@rhul.ac.uk) for details or support | LICENSE.md for license details */
var MAX_LOG_DEPTH = 2;

var ObjectHelper = function ObjectHelper() {
  _classCallCheck(this, ObjectHelper);
};

ObjectHelper.functionName = function (fn) {
  return fn.name || "anonymous";
};

ObjectHelper.safe = function (item) {
  item.__safe_item_to_string = true;
};

ObjectHelper.isSafe = function (item) {
  return item && item.__safe_item_to_string;
};

ObjectHelper.startsWith = function (str1, searchString) {
  return str1.substr(0, searchString.length) === searchString;
};

ObjectHelper.repeat = function (str, count) {
  var repeatedStr = "";

  while (count > 0) {
    repeatedStr += str;
    count--;
  }

  return repeatedStr;
};

ObjectHelper.enumerate = function (item, depth) {
  if (depth < MAX_LOG_DEPTH) {
    if (item instanceof Array) {
      return "[" + item.reduce(function (last, next) {
        return last + (last.length == 0 ? "" : ", ") + ObjectHelper.asString(next, false, depth + 1);
      }, "") + "]";
    } else if (item instanceof Object) {
      var result = "{";
      var first = true;

      for (var property in item) {
        result += (first ? "" : ",") + "\n" + ObjectHelper.repeat("    ", depth + 1) + property + ": " + ObjectHelper.asString(item[property], false, depth + 1);
        first = false;
      }

      result += "\n}";
      return result;
    }
  } else {
    return "Max Depth";
  }

  return "Unstringable";
};

ObjectHelper.asString = function (item, forceSafe, depth) {
  //If depth is undefined make it 0
  depth = depth || 0;

  if (item instanceof Function) {
    return ObjectHelper.functionName(item);
  }

  if (typeof item === "number" || typeof item === "boolean" || typeof item === "string" || item === undefined || item === null) {
    return "" + item;
  }

  if (forceSafe || ObjectHelper.isSafe(item)) {
    return item.toString();
  } else if (item instanceof Symbol) {
    return "Unstringable";
  } else {
    return ObjectHelper.enumerate(item, depth);
  }
};

var _default = ObjectHelper;
exports["default"] = _default;
},{}],21:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

/* Copyright (c) Royal Holloway, University of London | Contact Blake Loring (blake@parsed.uk), Duncan Mitchell (Duncan.Mitchell.2015@rhul.ac.uk), or Johannes Kinder (johannes.kinder@rhul.ac.uk) for details or support | LICENSE.md for license details */
function _default(sandbox, sid, iid) {
  var iid_string = sandbox.iidToLocation(sid, iid);

  if (!iid_string) {
    return undefined;
  }

  return iid_string.substr(1, iid_string.length - 2).split(":").slice(1); //Comes in the form (Filename:1:2:3:4)   
}
},{}],22:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SymbolicObject = void 0;

var _WrappedValue2 = require("./WrappedValue");

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var SymbolicObject = /*#__PURE__*/function (_WrappedValue) {
  _inherits(SymbolicObject, _WrappedValue);

  var _super = _createSuper(SymbolicObject);

  function SymbolicObject(name) {
    var _this;

    _classCallCheck(this, SymbolicObject);

    _this = _super.call(this, {});
    _this._name = name;
    _this._core = _this.getConcrete();
    _this._set = {};
    _this._lastIndex = 0;
    return _this;
  }

  _createClass(SymbolicObject, [{
    key: "setField",
    value: function setField(state, offset, v) {
      state.stats.seen("Symbolic Object Field Overrides");
      this._core[offset] = v;
      this._set[offset] = true;
    }
  }, {
    key: "getField",
    value: function getField(state, offset) {
      state.stats.seen("Symbolic Object Field Lookups");

      if (!this._set[offset]) {
        //Can't use offset in name, if offset is a symbol is will crash
        this._core[offset] = state.createPureSymbol("".concat(this._name, "_elements_").concat(offset, "_").concat(this._lastIndex++));
      }

      return this._core[offset];
    }
  }, {
    key: "delete",
    value: function _delete(offset) {
      this._set[offset] = false;
      delete this._core[offset];
    }
  }]);

  return SymbolicObject;
}(_WrappedValue2.WrappedValue);

exports.SymbolicObject = SymbolicObject;
},{"./WrappedValue":23}],23:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ConcolicValue = exports.WrappedValue = void 0;

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/* Copyright (c) Royal Holloway, University of London | Contact Blake Loring (blake@parsed.uk), Duncan Mitchell (Duncan.Mitchell.2015@rhul.ac.uk), or Johannes Kinder (johannes.kinder@rhul.ac.uk) for details or support | LICENSE.md for license details */

/*
 * Original Concolic Value License
 *
 * Copyright 2013 Samsung Information Systems America, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// ES6 Translation / Blake Loring
var WrappedValue = /*#__PURE__*/function () {
  function WrappedValue(concrete) {
    _classCallCheck(this, WrappedValue);

    this.concrete = concrete;
  }

  _createClass(WrappedValue, [{
    key: "clone",
    value: function clone() {
      return new WrappedValue(this.concrete);
    }
  }, {
    key: "toString",
    value: function toString() {
      return "Wrapped(" + this.concrete + ", " + (this.rider ? this.rider.toString() : "") + ")";
    }
  }, {
    key: "valueOf",
    value: function valueOf() {
      return this.concrete ? this.concrete.valueOf() : this.concrete;
    }
  }, {
    key: "getConcrete",
    value: function getConcrete() {
      return this.concrete;
    }
  }]);

  return WrappedValue;
}();

exports.WrappedValue = WrappedValue;

var ConcolicValue = /*#__PURE__*/function (_WrappedValue) {
  _inherits(ConcolicValue, _WrappedValue);

  var _super = _createSuper(ConcolicValue);

  /**
   * TODO: I'm not sure I like passing array type with concolic values to sanity check comparisons
   */
  function ConcolicValue(concrete, symbolic) {
    var _this;

    var arrayType = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;

    _classCallCheck(this, ConcolicValue);

    _this = _super.call(this, concrete);
    _this.symbolic = symbolic;
    _this._arrayType = arrayType;
    return _this;
  }

  _createClass(ConcolicValue, [{
    key: "toString",
    value: function toString() {
      return "Concolic(" + this.concrete + ", " + this.symbolic + ")";
    }
  }, {
    key: "clone",
    value: function clone() {
      return new ConcolicValue(this.concrete, this.symbolic);
    }
  }, {
    key: "getConcrete",
    value: function getConcrete() {
      return this.concrete;
    }
  }, {
    key: "getSymbolic",
    value: function getSymbolic() {
      return this.symbolic;
    }
  }, {
    key: "getArrayType",
    value: function getArrayType() {
      return this._arrayType;
    }
  }]);

  return ConcolicValue;
}(WrappedValue);

exports.ConcolicValue = ConcolicValue;

ConcolicValue.getSymbolic = function (val) {
  return val instanceof ConcolicValue ? val.symbolic : undefined;
};

ConcolicValue.setSymbolic = function (val, val_s) {
  if (val instanceof ConcolicValue) {
    val.symbolic = val_s;
  }
};
},{}],24:[function(require,module,exports){

},{}],25:[function(require,module,exports){
// shim for using process in browser
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) { return [] }

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };

},{}],26:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/* Copyright (c) Royal Holloway, University of London | Contact Blake Loring (blake@parsed.uk), Duncan Mitchell (Duncan.Mitchell.2015@rhul.ac.uk), or Johannes Kinder (johannes.kinder@rhul.ac.uk) for details or support | LICENSE.md for license details */
var SET_TAG = 'set';
var SEEN_TAG = 'seen';
var MAX_TAG = 'max';

var Stats = /*#__PURE__*/function () {
  function Stats() {
    _classCallCheck(this, Stats);

    this.data = {};
  }

  _createClass(Stats, [{
    key: "_entry",
    value: function _entry(title) {
      //Create a new entry if it doesn't exist
      if (!this.data[title]) {
        this.data[title] = {};
      }

      return this.data[title];
    }
  }, {
    key: "_taggedEntry",
    value: function _taggedEntry(title, tag) {
      var entry = this._entry(title);

      entry.tag = tag;
      return entry;
    }
  }, {
    key: "_getSet",
    value: function _getSet(entry) {
      if (!entry.payload) {
        entry.payload = {};
        delete entry.payload.toString;
      }

      return entry.payload;
    }
  }, {
    key: "set",
    value: function set(title, item) {
      var entry = this._taggedEntry(title, SET_TAG);

      var set = this._getSet(entry);

      item = '#' + item;

      if (set[item]) {
        set[item] += 1;
      } else {
        set[item] = 1;
      }
    }
  }, {
    key: "seen",
    value: function seen(title) {
      var entry = this._taggedEntry(title, SEEN_TAG);

      entry.payload = entry.payload ? entry.payload + 1 : 1;
    }
  }, {
    key: "max",
    value: function max(title, val) {
      var entry = this._taggedEntry(title, MAX_TAG);

      entry.payload = entry.payload ? Math.max(entry.payload, val) : val;
    }
  }, {
    key: "final",
    value: function final() {
      return this.data;
    }
  }, {
    key: "export",
    value: function _export() {
      return JSON.stringify(this.data);
    }
  }, {
    key: "_mergeSet",
    value: function _mergeSet(data, title) {
      var pl = data[title].payload;

      for (var i in pl) {
        var entry = this._taggedEntry(title, SET_TAG);

        var set = this._getSet(entry);

        if (!set[i]) {
          set[i] = 0;
        }

        set[i] += pl[i];
      }
    }
  }, {
    key: "_mergeSeen",
    value: function _mergeSeen(data, title) {
      //Just add the two payloads together for num stats
      var entry = this._taggedEntry(title, SEEN_TAG);

      if (!entry.payload) {
        entry.payload = 0;
      }

      entry.payload += data[title].payload;
    }
  }, {
    key: "_mergeMax",
    value: function _mergeMax(data, title) {
      var entry = this._taggedEntry(title, MAX_TAG);

      entry.payload = entry.payload || 0;
      entry.payload = Math.max(data[title].payload, entry.payload);
    }
  }, {
    key: "_mergeField",
    value: function _mergeField(data, title) {
      switch (data[title].tag) {
        case SET_TAG:
          this._mergeSet(data, title);

          break;

        case SEEN_TAG:
          this._mergeSeen(data, title);

          break;

        case MAX_TAG:
          this._mergeMax(data, title);

          break;

        default:
          throw 'Bad Merge';
      }
    }
  }, {
    key: "merge",
    value: function merge(data) {
      data = JSON.parse(data);

      for (var entry in data) {
        this._mergeField(data, entry);
      }
    }
  }]);

  return Stats;
}();

var _default = Stats;
exports["default"] = _default;
},{}]},{},[1]);
